package inettools;

import java.io.IOException;
import java.io.InputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import lib.GraphicControls.MessageBox;
import lib.Resources.ResourcesUTF8;

public class Irc extends MIDlet implements CommandListener, WindowListener {
	public final static String VERSION = "1.7 beta 6";

	private final static int MAIN_MENU = 0;
	private final static int FORM_PROFILES = 1;
	private final static int FORM_CONFIG = 2;
	private final static int FORM_CONFIG_EDIT = 3;
	private final static int FORM_SETTINGS = 4;

	public static boolean minimized = false;
	public static Displayable lastDisplay;
	
	public static ResourcesUTF8 language;
	private boolean isLanguage;

	public static Display display;
	protected static List mainmenu;
	private MessageBox mb;
	private int currentform;
	private boolean running;

	// these are initialized on connection time
	private static IrcConnection irc;
	private static Listener listener; // irc listener

	private static UIHandler uihandler;
	private static Database db;

	private Command cmd_connect, cmd_profiles, cmd_settings, cmd_exit;
	private Command cmd_profile_add, cmd_profile_edit, cmd_profile_delete;
	private Command cmd_ok, cmd_cancel, cmd_back;

	private TextField tf_profilename, tf_nick, tf_altnick, tf_host, tf_port, tf_channels, tf_username, tf_realname, tf_start_commands, tf_quit_message;
	private TextField tf_passwd, tf_buflines, tf_height_diff, tf_pooltime;
	private ChoiceGroup cg_misc, cg_font, cg_encoding, cg_notification, cg_notificationtypes, cg_;
	private TextBox tb;

	//private static Player info, action, message;
	
	public static String QUIT_MESSAGE;

	private List list_profile;

	private TextField tf_ctcp_info, tf_template_query;
	

	public Irc() {
		display = Display.getDisplay(this);
		new Images();
		new Resources();
		language = new ResourcesUTF8 ("/language.dat");
		isLanguage = language.load();
		mainmenu = new List("InetTools IRC "+VERSION, List.IMPLICIT);
		mainmenu.append(language.get("connect"), Images.icons.getImage(0));  
		mainmenu.append(language.get("profiles"), Images.icons.getImage(0));
		mainmenu.append(language.get("settings"), Images.icons.getImage(0)); 
		mainmenu.append(language.get("about"), Images.icons.getImage(0)); 
		mainmenu.append(language.get("exit"), Images.icons.getImage(0));
		mainmenu.setCommandListener(this);


		cmd_connect = 	new Command(Irc.language.get("connect"), Command.OK, 1);
		cmd_profiles = 	new Command(Irc.language.get("profiles"), Command.SCREEN, 2);
		cmd_settings = 	new Command(Irc.language.get("settings"), Command.SCREEN, 3);
		cmd_exit = 		new Command(Irc.language.get("exit"), Command.EXIT, 6);

		cmd_profile_add = 		new Command(Irc.language.get("profileadd"), Command.SCREEN, 2);
		cmd_profile_edit = 		new Command(Irc.language.get("profileedit"), Command.SCREEN, 3);
		cmd_profile_delete = 	new Command(Irc.language.get("profiledelete"), Command.SCREEN, 4);

		cmd_ok = 		new Command(Irc.language.get("ok"), Command.OK, 1);
		cmd_cancel = 	new Command(Irc.language.get("cancel"), Command.EXIT, 10);
		cmd_back = 		new Command(Irc.language.get("back"), Command.EXIT, 10);

		db = new Database();
		running = false;
		//load_sounds();
	}

	public void startApp(){
		if(isLanguage)
		if(minimized){
			display.setCurrent(lastDisplay);
		}else if (!running){
			db.load();
/*			if(db.userId == 0){
				String platf = System.getProperty("microedition.platform");
				if(platf == null | platf.equals("j2me")) platf = "Unknown+model";
				try {
					getViaHttpConnection("http://xaoc.dimonvideo.ru/counter.php?act=add&user="+db.userId+"&phone="+platf+"&prog=InetTools+IRC&ver="+VERSION);
				} catch (IOException ioe){}
			} */
			display.setCurrent(mainmenu);
			currentform = MAIN_MENU;
			running = true;
		}
	}

	private void getViaHttpConnection(String url) throws IOException {
        HttpConnection c = null;
        InputStream is = null;
        String userId = null;
        try {
            c = (HttpConnection)Connector.open(url);
            is = c.openInputStream();
            int len = (int)c.getLength();
            if (len <= 0) {
                int ch;
                while ((ch = is.read()) != -1) {
                	if(userId == null) 	userId = "" +(char)ch;
                	else 				userId += (char)ch;
                }
                db.userId = parseInt(userId);
                db.save_advanced();
            }
        } finally {
            if (is != null)
                is.close();
            if (c != null)
                c.close();
        }
    }

	public void commandAction(Command cmd, Displayable disp) {
		if (cmd == cmd_connect) {
			QUIT_MESSAGE = db.quit_message;
			irc = (IrcConnection) new SocketIrc(db.encoding);
			uihandler = new UIHandler(this, db, display);
			uihandler.setDisplay(uihandler.getConsole());
			listener = new Listener(db, irc, uihandler);
			listener.start();
			System.gc();
		}
		else if (cmd == cmd_exit) {
			try {
				destroyApp(true);
			} catch (MIDletStateChangeException msce) { ; } // this never happens
			notifyDestroyed();
			System.gc();
		}
		else if (cmd == List.SELECT_COMMAND && currentform == MAIN_MENU) {
			String menuitem = mainmenu.getString(mainmenu.getSelectedIndex());
			if (menuitem.equals(language.get("connect"))) 
				this.commandAction(cmd_connect, null);
			if (menuitem.equals(language.get("profiles"))) 
				this.commandAction(cmd_profiles, null);
			if (menuitem.equals(language.get("settings"))) 
				this.commandAction(cmd_settings, null);
			if (menuitem.equals(language.get("about"))){
				//About about = new About(display, this, null, null, cmd_back, Irc.language.get("about"), Irc.language.get("aboutvalue1")+'\n'+Irc.language.get("aboutvalue2")+'\n'+Irc.language.get("aboutvalue3"), MessageBox.TYPE_INFO, Font.SIZE_SMALL, db.height_diff);
				mb = new MessageBox(display, this, null, null, cmd_back, Irc.language.get("about"), Irc.language.get("aboutvalue1")+'\n'+Irc.language.get("aboutvalue2")+'\n'+Irc.language.get("aboutvalue3"), MessageBox.TYPE_INFO, Font.SIZE_SMALL, db.height_diff);
//				mb.textlist.addText("\n   ,   ,    :  ,    ,    ..");
//				mb.textlist.addText("\n     : Javer, aTIX, OvZ, mincOrel, NEOSoftware, LinFor, Ilya, eps, HIZRI, ETC, Pentik, halmer, Sotneo.");
//				mb.textlist.addText("\n , .");
				display.setCurrent(mb);
			}
			if (menuitem.equals(language.get("exit"))) 
				this.commandAction(cmd_exit, null);
		}
		else if (cmd == cmd_back) {
			display.setCurrent(mainmenu);
		}
		else if ((cmd == cmd_ok || cmd == cmd_cancel || cmd == List.SELECT_COMMAND) && currentform != MAIN_MENU) {
			if (currentform == FORM_PROFILES) {
				currentform = MAIN_MENU;

				db.profileidx = list_profile.getSelectedIndex();
				db.save_profile();
				list_profile = null;

				db.setProfile(db.profileidx);
				display.setCurrent(mainmenu);
			}
			else if (currentform == FORM_CONFIG || currentform == FORM_CONFIG_EDIT) {
				boolean editing = (currentform == FORM_CONFIG_EDIT);

				if (cmd == cmd_ok) {
					if (tf_nick.getString().equals("")) {
						Alert a = new Alert(language.get("error"), language.get("nonickerror"), null, AlertType.WARNING);
						a.setTimeout(Alert.FOREVER);
						display.setCurrent(a);
						return;
					}else if (tf_realname.getString().equals("")) {
						Alert a = new Alert(language.get("error"), language.get("noidenterror"), null, AlertType.WARNING);
						a.setTimeout(Alert.FOREVER);
						display.setCurrent(a);
						return;
					}else if (tf_username.getString().equals("")) {
						Alert a = new Alert(language.get("meerror"), language.get("nonameerror"), null, AlertType.WARNING);
						a.setTimeout(Alert.FOREVER);
						display.setCurrent(a);
						return;
					}
					currentform = FORM_PROFILES;
					db.profilename = tf_profilename.getString();
					db.nick = tf_nick.getString();
					db.altnick = tf_altnick.getString();
					db.host = tf_host.getString();
					db.port = parseInt(tf_port.getString());
					db.channels = tf_channels.getString();
					db.username = tf_username.getString();
					db.realname = tf_realname.getString();
					db.passwd = tf_passwd.getString();
					db.start_commands = tf_start_commands.getString();
					db.quit_message = tf_quit_message.getString();

					if (editing)
						db.editProfile(list_profile.getSelectedIndex());
					else
						db.addProfile();
				}
				currentform = FORM_PROFILES;
				tf_profilename = null;
				tf_nick = null;
				tf_altnick = null;
				tf_host = null;
				tf_port = null;
				tf_channels = null;
				tf_username = null;
				tf_realname = null;
				tf_passwd = null;
				tf_start_commands = null;
				tf_quit_message = null;

				if (cmd == cmd_ok)
					commandAction(cmd_profiles, null);
				else
					display.setCurrent(list_profile);
			}
			else if (currentform == FORM_SETTINGS) {
				currentform = MAIN_MENU;
				if (cmd == cmd_ok) {
					db.timestamp = cg_misc.isSelected(0);
					db.usecolor = cg_misc.isSelected(1);
					db.smiles = cg_misc.isSelected(2);
					db.showinput = cg_misc.isSelected(3);
					db.showhosts = cg_misc.isSelected(4);
					db.ajoinkick = cg_misc.isSelected(5);
					db.showtime = cg_misc.isSelected(6);
					db.poolmode = cg_misc.isSelected(7);
					
					db.vibra = cg_notificationtypes.isSelected(0);
					db.sound = cg_notificationtypes.isSelected(1);
					db.light = cg_notificationtypes.isSelected(2);

					db.onquery = cg_notification.isSelected(0);
					db.onaddress = cg_notification.isSelected(1);
					db.onnotice = cg_notification.isSelected(2);
					db.onaction = cg_notification.isSelected(3);

					if (cg_font.getSelectedIndex() == 0) db.fontsize = Font.SIZE_SMALL;
					else if (cg_font.getSelectedIndex() == 1) db.fontsize = Font.SIZE_MEDIUM;
					else if (cg_font.getSelectedIndex() == 2) db.fontsize = Font.SIZE_LARGE;
									
					db.encoding = cg_encoding.getString(cg_encoding.getSelectedIndex());
					db.height_diff = parseInt(tf_height_diff.getString());
					db.pooltime = parseInt(tf_pooltime.getString());
					db.buflines = parseInt(tf_buflines.getString());
					db.ctcp_info = tf_ctcp_info.getString();
					db.template_query = tf_template_query.getString();
					db.save_advanced();
				}
				cg_misc = null;
				cg_notificationtypes = null;
				cg_notification = null;
			   	cg_font = null;
				cg_encoding = null;
				tf_height_diff = null;
				tf_pooltime = null;
				tf_buflines = null;
				tf_ctcp_info = null;
				tf_template_query = null;
				display.setCurrent(mainmenu);
			}

		}
		else {
			Form cfgform;

			if (cmd == cmd_profiles) {
				String[] profiles;

				profiles = db.getProfiles();
				list_profile = new List(language.get("profiles"), List.IMPLICIT);
				for (int i=0; i<profiles.length; i++) {
					list_profile.append(profiles[i], null);
				}
				if (db.profileidx > 0)
					list_profile.setSelectedIndex(db.profileidx, true);

				list_profile.addCommand(cmd_profile_add);
				list_profile.addCommand(cmd_profile_edit);
				list_profile.addCommand(cmd_profile_delete);
				list_profile.addCommand(cmd_ok);
				list_profile.setCommandListener(this);

				display.setCurrent(list_profile);
				currentform = FORM_PROFILES;
				if(profiles.length == 0)
					this.commandAction(cmd_profile_add,null);
					
				return;
			}
			else if (cmd == cmd_profile_add || cmd == cmd_profile_edit) {
				if (cmd == cmd_profile_edit)
					db.setProfile(list_profile.getSelectedIndex());
				else
					db.setProfile(-1);

				tf_profilename = 	new TextField(language.get("profilename"), db.profilename, 50, TextField.ANY);
				tf_nick = 			new TextField(language.get("nick"), db.nick, 50, TextField.ANY);
				tf_altnick = 		new TextField(language.get("altnick"), db.altnick, 50, TextField.ANY);
				tf_host = 			new TextField(language.get("server"), db.host, 200, TextField.URL);
				tf_port = 			new TextField(language.get("port"), new Integer(db.port).toString(), 5, TextField.NUMERIC);
				tf_channels =		new TextField(language.get("channels"), db.channels, 600, TextField.ANY);
				tf_username = 		new TextField(language.get("username"), db.username, 50, TextField.ANY);
				tf_realname =		new TextField(language.get("realname"), db.realname, 50, TextField.ANY);
				tf_passwd = 		new TextField(language.get("serverpassword"), db.passwd, 50, TextField.PASSWORD);
				tf_start_commands = new TextField(language.get("startcommands"), db.start_commands, 1000, TextField.ANY);
				tf_quit_message = 	new TextField(language.get("quitmessage"), db.quit_message, 1000, TextField.ANY);

				cfgform = new Form(language.get("profiles"));
				cfgform.append(tf_profilename);
				cfgform.append(tf_nick);
				cfgform.append(tf_altnick);
				cfgform.append(tf_host);
				cfgform.append(tf_port);
				cfgform.append(tf_channels);
				cfgform.append(tf_username);
				cfgform.append(tf_realname);
				cfgform.append(tf_passwd);
				cfgform.append(tf_start_commands);
				cfgform.append(tf_quit_message);

				if (cmd == cmd_profile_edit)
					currentform = FORM_CONFIG_EDIT;
				else
					currentform = FORM_CONFIG;
			}
			else if (cmd == cmd_profile_delete) {
				db.deleteProfile(list_profile.getSelectedIndex());
				commandAction(cmd_profiles, null);
				return;
			}
			else if (cmd == cmd_settings) {
				cg_misc = new ChoiceGroup(language.get("miscoptions"), ChoiceGroup.MULTIPLE);
				cg_misc.append(language.get("timestamp"), null);
				cg_misc.append(language.get("colors")+", "+Irc.language.get("styles"), null);
				cg_misc.append(language.get("smiles"), null);
				cg_misc.append(language.get("servermessages"), null);
				cg_misc.append(language.get("showhosts"), null);
				cg_misc.append(language.get("autojoinafterkick"), null);
				cg_misc.append(language.get("showtime"), null);
				cg_misc.append(language.get("socketping"), null);
				cg_misc.setSelectedIndex(0, db.timestamp);
				cg_misc.setSelectedIndex(1, db.usecolor);
				cg_misc.setSelectedIndex(2, db.smiles);
				cg_misc.setSelectedIndex(3, db.showinput);
				cg_misc.setSelectedIndex(4, db.showhosts);
				cg_misc.setSelectedIndex(5, db.ajoinkick);
				cg_misc.setSelectedIndex(6, db.showtime);
				cg_misc.setSelectedIndex(7, db.poolmode);

				cg_notificationtypes = new ChoiceGroup(language.get("notificationtypes"), ChoiceGroup.MULTIPLE);
				cg_notificationtypes.append(language.get("vibra"), null);
				cg_notificationtypes.append(language.get("sounds"), null);
				cg_notificationtypes.append(language.get("light"), null);
				cg_notificationtypes.setSelectedIndex(0, db.vibra);
				cg_notificationtypes.setSelectedIndex(1, db.sound);
				cg_notificationtypes.setSelectedIndex(2, db.light);

				cg_notification = new ChoiceGroup(language.get("notification"), ChoiceGroup.MULTIPLE);
				cg_notification.append(language.get("query"), null);
				cg_notification.append(language.get("address"), null);
				cg_notification.append(language.get("notice"), null);
				cg_notification.append(language.get("action"), null);
				cg_notification.setSelectedIndex(0, db.onquery);
				cg_notification.setSelectedIndex(1, db.onaddress);
				cg_notification.setSelectedIndex(2, db.onnotice);
				cg_notification.setSelectedIndex(3, db.onaction);
				
				cg_font = new ChoiceGroup(language.get("font"), ChoiceGroup.EXCLUSIVE);
				cg_font.append(language.get("smallphonefont"), null);
				cg_font.append(language.get("mediumphonefont"), null);
				cg_font.append(language.get("largephonefont"), null);
				if (db.fontsize == Font.SIZE_SMALL) cg_font.setSelectedIndex(0, true);
				else if (db.fontsize == Font.SIZE_MEDIUM) cg_font.setSelectedIndex(1, true);
				else if (db.fontsize == Font.SIZE_LARGE) cg_font.setSelectedIndex(2, true);
				else cg_font.setSelectedIndex(0, true);

				cg_encoding = new ChoiceGroup(language.get("encoding"), ChoiceGroup.EXCLUSIVE);
				cg_encoding.append("ISO-8859-1", null);
				cg_encoding.append("ISO-8859-2", null);
				cg_encoding.append("UTF-8", null);
				cg_encoding.append("KOI8-R", null);
				cg_encoding.append("Windows-1251", null);
				if (db.encoding.equals("ISO-8859-1")) cg_encoding.setSelectedIndex(0, true);
				else if (db.encoding.equals("ISO-8859-2")) cg_encoding.setSelectedIndex(1, true);
				else if (db.encoding.equals("UTF-8")) cg_encoding.setSelectedIndex(2, true);
				else if (db.encoding.equals("KOI8-R")) cg_encoding.setSelectedIndex(3, true);
				else if (db.encoding.equals("Windows-1251")) cg_encoding.setSelectedIndex(4, true);
				else cg_encoding.setSelectedIndex(0, true);

				tf_height_diff = 	new TextField(language.get("displayheightincrease"), new Integer(db.height_diff).toString(), 3, TextField.NUMERIC);
				tf_pooltime = 		new TextField(language.get("socketpingtime"), new Integer(db.pooltime).toString(), 5, TextField.NUMERIC);
				tf_buflines = 		new TextField(language.get("buffer"), new Integer(db.buflines).toString(), 3, TextField.NUMERIC);
				tf_ctcp_info = 		new TextField(language.get("userinfolabel"), db.ctcp_info, 1000, TextField.ANY);
				tf_template_query = new TextField(language.get("templatequery"), db.template_query, 1000, TextField.ANY);
				

				cfgform = new Form(language.get("settings"));
				cfgform.append(cg_misc);
				cfgform.append(tf_pooltime);
				cfgform.append(cg_notificationtypes);
				cfgform.append(cg_notification);
				cfgform.append(cg_font);
				cfgform.append(cg_encoding);
				cfgform.append(tf_height_diff);
				cfgform.append(tf_buflines);
				cfgform.append(tf_ctcp_info);
				cfgform.append(tf_template_query);
				currentform = FORM_SETTINGS;
			}
			else return;

			cfgform.addCommand(cmd_ok);
			cfgform.addCommand(cmd_cancel);
			cfgform.setCommandListener(this);

			display.setCurrent(cfgform);
		}
	}
	
/*	private void load_sounds(){
	    try
	    {
		      InputStream is = getClass().getResourceAsStream("/sounds/info.mid");
		      info = Manager.createPlayer(is, "audio/midi");
		      info.prefetch();
		      is.close();
		      InputStream is1 = getClass().getResourceAsStream("/sounds/action.mid");
		      action = Manager.createPlayer(is1, "audio/midi");
		      action.prefetch();
		      is.close();
		      InputStream is2 = getClass().getResourceAsStream("/sounds/message.mid");
		      message = Manager.createPlayer(is2, "audio/midi");
		      message.prefetch();
		      is.close();
	    }catch(Exception e) {}
	}
	
	public static void play_sound(String filename)
	  {
	    Player player = null;
	    try {
	    	   player.stop();
	    	   }
	    catch (Exception e1) {}
	    try
	    {	
	    	if(filename.equals("info")){
	    		info.start();
	    	}else if(filename.equals("action")){
	    		action.start();
	    	}else if(filename.equals("message")){
	    		message.start();
	    	}

	    }catch(Exception e) {player = null; }
	  }  

*/
	/**
	 * Time to pause, free any space we don't need right now.
	 */
	public void pauseApp() {
//FIXME		Irc.writeLine("NICK " + UIHandler.nick+"_");
//		UIHandler.nick = UIHandler.nick + "_"; 
	}
	

	/**
	 * Destroy must cleanup everything.
	 */
	public void destroyApp(boolean unconditional) throws MIDletStateChangeException {
		if (irc != null && irc.isConnected()) {
			if (!unconditional)
				throw new MIDletStateChangeException(language.get("error"));

			Irc.disconnect("QUIT : "+db.quit_message);
		}
	}
	

	private int parseInt(String input) {
		int ret = 0;

		try {
			ret = Integer.parseInt(input);
		} catch (NumberFormatException nfe) {}

		return ret;
	}


	// Static functions called from other classes
	public static void writeLine(String message) {
		if (irc.isConnected()) {
			String ret = irc.writeData(message + "\r\n");
			if (ret != null) {
				uihandler.getConsole().writeInfo(ret);
			}
			listener.setNeedUpdate(true);
		}
	}

	public static void forceUpdate() {
		listener.setNeedUpdate(true);
	}

	public static void disconnect(String quitmessage) {
		if (irc.isConnected()) {
			String ret = irc.writeData(quitmessage + "\r\n");
			if (ret != null) {
				uihandler.getConsole().writeInfo(ret);
			}
			listener.setNeedUpdate(true);
			listener = null;
			uihandler = null;
			irc.disconnect();
		}
	}

	public static int getBytesIn() {
		return irc.getBytesIn();
	}

	public static int getBytesOut() {
		return irc.getBytesOut();
	}
	
	public void openUrl(String url){
		try {platformRequest(url);} 
		catch (Exception e) {e.printStackTrace();}
	}

	public void onUrlSelect(Window sender, String url) {
		openUrl(url);
	}
	
}
