package inettools;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.rms.RecordStore;

import lib.GraphicControls.Emotions;

public class UIHandler {
	public static final String SMILES[][] = {
			{":-)", ":)"},
			{":-(", ":(", ":-((", ":((", ":-(((", ":((("},
			{";-)", ";)", ";-))", ";))"},
			{":-P", ":P", ":-p", ":p", "%)"},
			{"O:-)", "O:)", "o:-)"},
			{":'(", ":\"(", ";-(", ";("},
			{"*KISSED*"},
			{":-*", ":*"},
			{":-[", ":["},
			{">:o", ">:|", ">:O", ">:0", ">:(", "*MAD*"},
			{":-X", ":X", ":-x", ":x"},
			{":-\\", ":-/", ":-|", ":|"},
			{"=-O", "WOW", "wow"},
			{":-D", ":D", ":-))))", ":))))", "*YAHOO*"},
			{":-!", ":!"},
			{"=-)"},
			{"8-)", "8)", "B-)", "B)", "*COOLBOY*"},
			{"[:-}", "[:-)", "[:)"},
			{":-$", ":$", "*TIRED*"},
			{"@="},
			{"*STOP*"},
			{"*KISSING*"},
			{"]:->", ":->"},
			{"@}->--","@};-"},
			{"*THUMBS UP*"},
			{"*DRINK*", "*BEER*", "[~]D"},
			{"*IN LOVE*", "*HEART*"},
			{"*JOKINGLY*", ":-))", ":))", ":-)))", ":)))", "=)"},
			};

	private Display display;
	private Window console;
	private boolean smiles;
	private boolean timestamp;
	private boolean winlock;
	private boolean usecol;
	private int height_diff;
	private int buflines;
	public Hashtable channels, privates;
	private Vector windows; // excludes console
	private Vector favourites, slaps;
	private int currentwin;
	String template_query;

	private int fontsize;
	
	public WindowListener wl;
	
	private boolean[] notification;

	public static String nick, message;
	public static char nickMode;
	public boolean keylock;
	public Emotions emotions;
	
	public Image ti = null;
	public Graphics tg;
	
	private boolean showtime;

	public UIHandler(WindowListener wl, Database db, Display disp) {
		nick = db.nick;
		keylock = false;
		emotions = new Emotions(SMILES, "/images/smiles.png", 16);

		smiles = db.smiles;
		timestamp = db.timestamp;
		height_diff = db.height_diff;
		buflines = db.buflines;
		usecol = db.usecolor;
		fontsize = db.fontsize;
		display = disp;
		template_query = db.template_query;
		showtime = db.showtime;
		this.wl = wl;

		notification = new boolean[]{db.vibra, db.sound, db.light, db.onquery, db.onaddress, db.onnotice, db.onaction};
		
		winlock = false;
		channels = new Hashtable();
		privates = new Hashtable();
		windows = new Vector();
		loadFavs();
		loadSlaps();
		currentwin = 0;
		console = new Window(this, Irc.language.get("statuswnd"), Window.TYPE_CONSOLE, smiles, timestamp, usecol, height_diff, buflines, fontsize, notification, showtime, wl);
		addWindow(console);
		
	}

	public Window getConsole() {
		return console;
	}

	public Window getChannel(String channel) {
		Window win;

		channel = channel.trim();
		win = (Window) channels.get(channel.toUpperCase());

		if (win == null) {
			win = new Window(this, channel, Window.TYPE_CHANNEL, smiles, timestamp, usecol, height_diff, buflines, fontsize, notification, showtime, wl);
			channels.put(channel.toUpperCase(), win);
			addWindow(win);
		}
		return win;
	}

	public Window getPrivate(String priv) {
		Window win;

		priv = priv.trim();
		win = (Window) privates.get(priv.toUpperCase());
		if (win == null) {
			win = new Window(this, priv, Window.TYPE_PRIVATE, smiles, timestamp, usecol, height_diff, buflines, fontsize, notification, showtime, wl);
			privates.put(priv.toUpperCase(), win);
			addWindow(win);

			// new private message coming, we play the alarm
			if (keylock) playAlarm(true);
		}
		return win;
	}

	public void addWindow(Window win) {
		windows.addElement(win);
		displayWindow(-1);
	}

	public int[] getIndicators() {
		int[] ret = new int[windows.size()];

		for (int i=0; i<windows.size(); i++) {
			if (i == currentwin) ret[i] = Window.STATE_SELECTED;
			else ret[i] = ((Window) windows.elementAt(i)).getState();
		}
		return ret;
	}
	public void globalHandleMsg(String msg){
		for (int i=1; i<windows.size(); i++) {
			((Window) windows.elementAt(i)).handleMsg(msg);
		}
	}
	
	public Window getCurrentWindow(){
		return ((Window) windows.elementAt(currentwin));
	}

	public void setHeader(boolean visible) {
		smiles = visible;

	}

	public void displayNextWindow() {
		displayWindow(currentwin+1);
	}

	public void displayPreviousWindow() {
		displayWindow(currentwin-1);
	}

	public void displayWindow(int num) {
		Window win;

		if (winlock) {
		return; 
		}// no window changing on winlock

		if (num >= windows.size()) num = 0;
		else if (num < 0) num = windows.size()-1;

		if (num != currentwin) {
			((Window) windows.elementAt(currentwin)).setState(Window.STATE_NONE);
			setDisplay((Window) windows.elementAt(num));
			currentwin = num;
		}
		System.gc();
	}

	public void deleteWindow(Window win) {
		if (win.getType() == Window.TYPE_PRIVATE)
			privates.remove(win.getName().toUpperCase());
		if (win.getType() == Window.TYPE_CHANNEL)
			channels.remove(win.getName().toUpperCase());

		windows.removeElement(win);
		currentwin--;
		setDisplay((Window) windows.elementAt(currentwin));
	}

	public void setDisplay(Displayable disp) {
		display.setCurrent(disp);
	}
	
	public Display getDisplay(){
		return display;
	}

	public Hashtable getChannels() {
		return channels;
	}
	public Hashtable getPrivates() {
		return channels;
	}

	public void clearChanPriv() {
		console.enterExitMode();

		if (currentwin >= 0) {
			setDisplay(console);
			currentwin = 0;
		}

		for (int i=windows.size()-1; i>=1; i--) {
			// we don't clear the windows, just put to closing mode
			((Window) windows.elementAt(i)).enterExitMode();
		}
		console.repaint();
	}

	public void cleanup() {
		windows.removeAllElements();
		channels.clear();
		privates.clear();
		currentwin = -1;

		System.gc();
		setDisplay(Irc.mainmenu);
	}

	public void repaint() {
		if (currentwin >= 0)
			((Window) windows.elementAt(currentwin)).repaint();
	}

	public void setWinlock(boolean lock) {
		winlock = lock;
	}

	public boolean playAlarm(boolean louder) {
		if (louder)
			return AlertType.ALARM.playSound(display);
		else
			return AlertType.INFO.playSound(display);
	}


    /*  */

	public void loadFavs() {
		try {
			RecordStore rs = RecordStore.openRecordStore("fav", true);
			favourites = new Vector();
			if (rs.getNumRecords() > 0) {
				byte[] record = rs.enumerateRecords(null, null, false).nextRecord();
				DataInputStream dis = new DataInputStream(new ByteArrayInputStream(record));
				int count = dis.readInt();

				for (int i=0; i<count; i++)
					favourites.addElement(dis.readUTF());

				dis.close();
			}
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void saveFavs() {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		DataOutputStream dos = new DataOutputStream(baos);
		try {
			dos.writeInt(favourites.size());
			for (int i=0; i<favourites.size(); i++)
				dos.writeUTF((String) favourites.elementAt(i));
			dos.close();
			baos.close();

			RecordStore.deleteRecordStore("fav");
			RecordStore rs = RecordStore.openRecordStore("fav", true);
			byte[] bytes = baos.toByteArray();
			rs.addRecord(bytes, 0, bytes.length);
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void addFav(String input) {
		for (int i=0; i<favourites.size(); i++) {
			if (input.compareTo((String) favourites.elementAt(i)) < 0) {
				favourites.insertElementAt(input, i);
				return;
			}
		}
		favourites.addElement(input);
	}

	public void removeFav(String input) {
		favourites.removeElement(input);
	}

	public Vector getFavs() {
		return favourites;
	}
	
	
    /*  */

	public void loadSlaps() {
		try {
			RecordStore rs = RecordStore.openRecordStore("slaps", true);
			slaps = new Vector();
			if (rs.getNumRecords() > 0) {
				byte[] record = rs.enumerateRecords(null, null, false).nextRecord();
				DataInputStream dis = new DataInputStream(new ByteArrayInputStream(record));
				int count = dis.readInt();

				for (int i=0; i<count; i++)
					slaps.addElement(dis.readUTF());

				dis.close();
			}
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(slaps.isEmpty()){
			slaps.addElement(Irc.language.get("slapexample1"));
			slaps.addElement(Irc.language.get("slapexample2"));
			slaps.addElement(Irc.language.get("slapexample3"));
		}
	}

	public void saveSlaps() {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		DataOutputStream dos = new DataOutputStream(baos);
		try {
			dos.writeInt(slaps.size());
			for (int i=0; i<slaps.size(); i++)
				dos.writeUTF((String) slaps.elementAt(i));
			dos.close();
			baos.close();

			RecordStore.deleteRecordStore("slaps");
			RecordStore rs = RecordStore.openRecordStore("slaps", true);
			byte[] bytes = baos.toByteArray();
			rs.addRecord(bytes, 0, bytes.length);
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void addSlap(String input) {
		for (int i=0; i<slaps.size(); i++) {
			if (input.compareTo((String) slaps.elementAt(i)) < 0) {
				slaps.insertElementAt(input, i);
				return;
			}
		}
		slaps.addElement(input);
	}

	public void removeSlap(String input) {
		slaps.removeElement(input);
	}

	public Vector getSlaps() {
		return slaps;
	}
}
