package inettools;

import java.util.Calendar;
import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;

import lib.GraphicControls.MessageBox;
import lib.GraphicControls.TextList;
import lib.Utils.Utils;
public class Window extends Canvas implements CommandListener {
	public static final int TYPE_CONSOLE = 0;
	public static final int TYPE_CHANNEL = 1;
	public static final int TYPE_PRIVATE = 2;

	public static final int STATE_NONE = 0;
	public static final int STATE_INFO = 1;
	public static final int STATE_MSG = 2;
	public static final int STATE_HILIGHT = 3;
	public static final int STATE_SELECTED = 4;

	public static final char MODE_NONE = 0;
	public static final char MODE_VOICE = 1;
	public static final char MODE_HALFOP = 2;
	public static final char MODE_OP = 4;

	
//	private Image ti;
//	private Graphics tg;
	
	//private moveCursor mc;
	
	private WindowListener wl;
	
	public MessageBox mb;
	
	private int type, state;
	private UIHandler uihandler;
	private Vector names;
	
	private Display display;
	
	public static TextBox textbox;
	
	private Form favform, optionsform, colmsgform, stylesform;
	private Command cmd_msg, cmd_join, cmd_query, cmd_favourites, cmd_traffic, cmd_disconnect, cmd_saveoptions;
	public Command cmd_closeconsole, cmd_closenamfav, cmd_applystyle, cmd_menu, cmd_smiles, cmd_textboxmenu;
	private Command cmd_delfav, cmd_sendfav, cmd_addnewfav, cmd_options, cmd_styles, cmd_commands, cmd_colmsg, cmd_addcol, cmd_textoptions;
	private Command cmd_addslap, cmd_editslap, cmd_delslap;

	private Command cmd_close;

	private Command cmd_whois;
	private Command cmd_names;

	private Command cmd_cancel;
	private Command cmd_send;
	private Command cmd_ok;

	private ChoiceGroup cg_favourites, cg_options, cg_colmsg, cg_colmsgfone, cg_styles;

	public String name, header, chansize, topic=" ";
	private long keylocktime;
	private int height_diff;
	private int buflines;
	private boolean timestamp;
	private TextArea textarea;
	private boolean showheader;
	private boolean usecol;
	private boolean smiles;

	private boolean vibra;
	private boolean sound;
	private int fontsize;

	private int width;
	private int height;
	
	private final static int MAX_LIST_PERSONS = 20;
	private int person_position = 0;

	private List nameslist;
	private List namecmdlist;
	private List commandslist;
	private List textoptionslist;
	private List menulist;
	private List textboxmenu;
	private List usermanagmentmenu;
	private List ctcpmenu;
	private List slapslist;

	String textstyle = "";
	private Command cmd_paste;
	private boolean[] notification;
	private Smiles sml;
	private boolean showtime;
	
	public Window(UIHandler uihandler, String name, int type, boolean smiles, boolean timestamp, boolean usecol, int height_diff, int buflines, int fontsize, boolean[] notification, boolean showtime, WindowListener wl) {
//		FIXME
//		 MIDP 2.0==========================
		     setFullScreenMode(true);
//		===================================        

		if(type == TYPE_CONSOLE){
	        width = getWidth();
			height = getHeight()+ height_diff;
		}else{
	        width = uihandler.getConsole().width;
	        height = uihandler.getConsole().height;
		}

		this.uihandler = uihandler;
		this.name = name;
		this.header = name;
		this.chansize = "";
		this.type = type;
		this.timestamp = timestamp;
		this.usecol = usecol;
		this.smiles = smiles;
		this.height_diff = height_diff;
		this.buflines = buflines;
		this.fontsize = fontsize;
		this.notification = notification;
		this.showtime = showtime;
		this.wl = wl;
		
		
		if(uihandler.ti == null){
			uihandler.ti = Image.createImage(width, height);
			uihandler.tg = uihandler.ti.getGraphics();
		}

		state = STATE_NONE;
		textarea = new TextArea(width-2, height-7-Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL).getHeight(), fontsize, TextList.CURSOR_RECT, buflines, uihandler);

		names = new Vector();

		cmd_ok = 			new Command(Irc.language.get("ok"), Command.OK, 10);
		cmd_send = 			new Command(Irc.language.get("send"), Command.OK, 10);
		cmd_paste =			new Command(Irc.language.get("paste"), Command.SCREEN, 20);
		cmd_smiles =		new Command(Irc.language.get("smiles"), Command.SCREEN, 20);
		cmd_colmsg = 		new Command(Irc.language.get("colors"), Command.SCREEN, 30);
		cmd_styles = 		new Command(Irc.language.get("styles"), Command.SCREEN, 40);
		cmd_textboxmenu = 	new Command(Irc.language.get("menu"), Command.ITEM, 100);
		cmd_cancel = 		new Command(Irc.language.get("cancel"), Command.SCREEN, 50);
		cmd_menu = 			new Command(Irc.language.get("menu"), Command.SCREEN, 20);
		cmd_applystyle =	new Command(Irc.language.get("apply"), Command.OK, 10);
		cmd_saveoptions = 	new Command(Irc.language.get("save"), Command.OK, 10);
		cmd_msg = 			new Command(Irc.language.get("message"), Command.OK, 10);
		cmd_favourites = 	new Command(Irc.language.get("favourites"), Command.SCREEN, 50);
		cmd_addslap = 		new Command(Irc.language.get("addslap"), Command.SCREEN, 50);
		cmd_editslap = 		new Command(Irc.language.get("editslap"), Command.SCREEN, 50);
		cmd_delslap = 		new Command(Irc.language.get("delslap"), Command.SCREEN, 50);
		cmd_traffic = 		new Command(Irc.language.get("traffic"), Command.SCREEN, 50);
		cmd_disconnect = 	new Command(Irc.language.get("disconnect"), Command.SCREEN, 90);
		cmd_close = 		new Command(Irc.language.get("close"), Command.SCREEN, 65);
		cmd_whois = 		new Command("Whois", Command.SCREEN, 35);
		cmd_names = 		new Command(Irc.language.get("userslist"), Command.SCREEN, 35);
		cmd_sendfav = 		new Command(Irc.language.get("send"), Command.OK, 10);
		cmd_addnewfav = 	new Command(Irc.language.get("addfavourite"), Command.SCREEN, 30);
		cmd_delfav = 		new Command(Irc.language.get("deletefavourite"), Command.SCREEN, 40);
		cmd_closeconsole=	new Command(Irc.language.get("close"), Command.CANCEL, 10);
		cmd_closenamfav = 	new Command(Irc.language.get("close"), Command.CANCEL, 90);
		cmd_addcol = 		new Command(Irc.language.get("addcolor"), Command.OK, 10);
		cmd_options = 		new Command(Irc.language.get("settings"), Command.SCREEN, 30);
		cmd_commands = 		new Command(Irc.language.get("commands"), Command.SCREEN, 40);
		cmd_join = 			new Command(Irc.language.get("joinchannel"), Command.SCREEN, 20);
		cmd_query = 		new Command(Irc.language.get("query"), Command.SCREEN, 30);
		cmd_textoptions = 	new Command(Irc.language.get("textoptions"), Command.SCREEN, 30);


		this.setCommandListener(this);
		sml = new Smiles(width, height);
//		mc = new moveCursor();
//		mc.start();
	}

	
	
	/* get and set methods here */
	public String getName() {
		return name;
	}
	
	public int getType() {
		return type;
	}

	public int getState() {
		return state;
	}

	public void setState(int newstate) {
		state = newstate;
	}
	
        /* change nick from Listener.java */
	public void nickChangeAction() {
		textbox = new TextBox(Irc.language.get("changenickaction"), "", 50, TextField.ANY);
		textbox.setCommandListener(new TextboxListener());
		textbox.addCommand(cmd_ok);
		uihandler.setWinlock(true);
		uihandler.setDisplay(textbox);
	}


	private void updateHeader() {
		chansize = " [" + names.size() + "]";
	}

	/* show and close methods */
	private void show() {
        setFullScreenMode(true);
		uihandler.setDisplay(this);
		repaint();
		System.gc();
	}

	public void clear() {
		textarea.clear();
		System.gc();
	}

	public void enterExitMode() {
		this.addCommand(cmd_closeconsole);
	}

	public void close() {
		uihandler.deleteWindow(this);
	}

	
	/* sending data from textbox on cmd_send, handles '/command' commands */
	public void handleMsg(String str) {
		if (str != null && str.length() > 0) {
			if (str.charAt(0) =='/') {
				String[] s = Utils.splitString(str, " ");
				String command = s[0].toUpperCase();
				if (command.equals("/MSG")) {
					Window win;

					if (s.length > 2) {
						Irc.writeLine("PRIVMSG " + s[1] +  " :" + str.substring(6 + s[1].length()));
						if (Utils.isChannel(s[1]))
							win = uihandler.getChannel(s[1]);
						else{
							win = uihandler.getPrivate(s[1]);
						}
						win.write(UIHandler.nick, str.substring(6 + s[1].length()));
						textbox = null;
						win.show();
						return;
					}
				}
				else if (command.equals("/ME")) {
					Irc.writeLine("PRIVMSG " + name +  " :\001ACTION " + str.substring(4) + "\001");
					writeAction("* " + UIHandler.nick + " " + str.substring(4));
					if(notification[6]){
						if(notification[1]) Resources.playAction();
						if(notification[2]) Resources.LCDFlash();
						if(notification[0]) Resources.vibrate();
					}
				}
				else if (command.equals("/LIST")) {
					Irc.writeLine("LIST");
					writeAction("* "+Irc.language.get("gettingchannelslist"));
				}
				else if (command.equals("/RAW")) {
					Irc.writeLine(str.substring(5));
					uihandler.getConsole().write("rawcmd", str.substring(5));
				}
				else if (command.equals("/WII")) {
					Irc.writeLine("WHOIS " + s[1] + " " + s[1]);
				}
				else if (command.equals("/NICK")) {
					Irc.writeLine("NICK " + s[1]);
					UIHandler.nick = s[1];
				}
				else if (command.equals("/TOPIC")) {
					if (type == TYPE_CHANNEL)
						Irc.writeLine("TOPIC " + name + " :" + str.substring(7));
				}
				else if (command.equals("/CTCP")) {
					Irc.writeLine("PRIVMSG "  + s[1] +  " :\001" + s[2] + "\001");
				}
				else if (command.equals("/PART")) {
					if (Utils.isChannel(s[1]))
						Irc.writeLine("PART " + s[1] + " :" + str.substring(7 + s[1].length()));
					else
						Irc.writeLine("PART " + name + " :" + str.substring(6));
				}
				else if (command.equals("/QUIT")) {
					Irc.disconnect("QUIT :" + str.substring(6));
				}
				else {
					Irc.writeLine(str.substring(1));
					uihandler.getConsole().writeInfo(str.substring(1));
				}
			}
			else if (type != TYPE_CONSOLE) {
				Irc.writeLine("PRIVMSG " + name + " :" + str);
				write(UIHandler.nick, str);
			}
		}
		textbox = null;
		show();
	}
	

	/* Text writing methods start here */
	public void write(String nick, String text) {
		int textIndex;
		if(notification[3] && !name.startsWith("#")){
			if(notification[1]) Resources.playMsg();
			if(notification[2]) Resources.LCDFlash();
			if(notification[0]) Resources.vibrate();
		}
		if(timestamp){
			Calendar cal = Calendar.getInstance();
			textarea.addText("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]", 0x999999, 0xffffff, Font.STYLE_PLAIN, Font.SIZE_SMALL);
			textIndex = textarea.items.size()-1;
//			textarea.messages.addElement("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]<"+ nick+ "> "+text);
		}else {
			textIndex = textarea.items.size();
//			textarea.messages.addElement("<"+ nick+ "> "+text);
		}
		if (text.indexOf(UIHandler.nick) > -1) {
			if(usecol)textarea.addIRCText("<"+ nick+ "> "+text, 0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex, smiles);
			else if(smiles)uihandler.emotions.addTextWithSmiles(textarea, "<"+ nick+ "> "+text,  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
			else textarea.addTextWithURL("<"+ nick+ "> "+text,  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
			
			if(textarea.currentItem >= textarea.items.size()-4)textarea.end();
			if (state<STATE_HILIGHT) state = STATE_HILIGHT;
			if (uihandler.keylock) uihandler.playAlarm(false);
			
			//if (!uihandler.keylock)Resources.LCDOn();
			if(notification[4]){
				if(notification[1]) Resources.playInfo();
				if(notification[2]) Resources.LCDFlash();
				if(notification[0]) Resources.vibrate();
			}
		}
		else {
			if(usecol){
				textarea.addIRCText("<"+ nick+ "> ", 0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex, smiles);
				textarea.addIRCText(text, textIndex, smiles);
			}else if(smiles){
				uihandler.emotions.addTextWithSmiles(textarea, "<"+ nick+ "> ",  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
				uihandler.emotions.addTextWithSmiles(textarea, text,  0x000000, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
			}else{
				textarea.addText("<"+ nick+ "> ",  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
				textarea.addTextWithURL(text,  0x000000, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
			}
			if(textarea.currentItem >= textarea.items.size()-4)textarea.end();
			//if (state<STATE_MSG) 
				state = STATE_MSG;
			
		//	if (!uihandler.keylock)Resources.LCDOn();
       }
		textarea.buffer();
		repaint();
	}
	public void writeAction(String str) {
		int textIndex;
		if(timestamp){
			Calendar cal = Calendar.getInstance();
			textarea.addText("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]", 0x999999, 0xffffff, Font.STYLE_PLAIN, Font.SIZE_SMALL);
			textIndex = textarea.items.size()-1;
//			textarea.messages.addElement("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]"+str);
		}else{
			textIndex = textarea.items.size();
//			textarea.messages.addElement(str);
		}
		if(usecol)textarea.addIRCText(str, 0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex, smiles);
		else if(smiles) uihandler.emotions.addTextWithSmiles(textarea, str,  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
		else textarea.addTextWithURL(str,  0x000000aa, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
		if(textarea.currentItem >= textarea.items.size()-4)textarea.end();
		if (state<STATE_INFO) state = STATE_INFO;
		
		//if (!uihandler.keylock)Resources.LCDOn();

		textarea.buffer();
		repaint();
	}

	public void writeInfo(String str) {
		int textIndex;
		if(timestamp){
			Calendar cal = Calendar.getInstance();
			textarea.addText("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]", 0x999999, 0xffffff, Font.STYLE_PLAIN, Font.SIZE_SMALL);
			textIndex = textarea.items.size()-1;
//			textarea.messages.addElement("[" + cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE) + "]"+str);
		}else{
			textIndex = textarea.items.size();
//			textarea.messages.addElement(str);
		}
		if(usecol)textarea.addIRCText("*** " + str, 0x0000d200, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex, smiles);
		else if(smiles) uihandler.emotions.addTextWithSmiles(textarea, "*** " + str, 0x0000d200, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
		else textarea.addTextWithURL("*** " + str, 0x0000d200, 0xffffff, Font.STYLE_PLAIN, fontsize, textIndex);
		if(textarea.currentItem >= textarea.items.size()-4)textarea.end();
		if (state<STATE_INFO) state = STATE_INFO;
		
		//if (!uihandler.keylock)Resources.LCDOn();

		textarea.buffer();
		repaint();
	}
	
	
	/* Nicklist editing functions start from here */
	public void addNick(char mode, String nick) {
		int i, nsize = names.size();
		String upnick = nick.toUpperCase();

		if(UIHandler.nick.toUpperCase().equals(nick.toUpperCase())) {
			UIHandler.nickMode = mode;
		}

		for (i=0; i<nsize; i++) {
			String str = (String) names.elementAt(i);

			if (str.charAt(0) > mode) continue;
			if (upnick.compareTo(str.substring(1).toUpperCase()) < 1 ||
			    str.charAt(0) < mode) {
				names.insertElementAt(mode + nick, i);
				break;
			}
		}
		if (i == nsize) names.addElement(mode + nick);
		updateHeader();
	}

	public boolean hasNick(String nick) {
		if (getNickIndex(nick) < 0) return false;
		else return true;
	}

	public void changeNick(String oldnick, String newnick) {
		int idx;
		
		if(name.equals(oldnick)) name = newnick;
		if ((idx = getNickIndex(oldnick)) >= 0) {
			char mode = ((String) names.elementAt(idx)).charAt(0);
			deleteNick(oldnick);
			addNick(mode, newnick);
		}
		
	}

	public void changeMode(char mode, String nick, boolean action) {
		int idx;

		if ((idx = getNickIndex(nick)) >= 0) {
			char oldmode = ((String) names.elementAt(idx)).charAt(0);
			deleteNick(nick);
			if (action)
				addNick((char) (oldmode | mode), nick);
			else
				addNick((char) (oldmode & ~mode), nick);
		}
	}

	public void deleteNick(String nick) {
		int idx;

		if ((idx = getNickIndex(nick)) >= 0) {
			names.removeElementAt(idx);
			updateHeader();
		}
	}

	public void deleteAllNicks() {
		names.removeAllElements();
	}

	public void printNicks() {
		if (names.size() > 10)
			writeInfo(Irc.language.get("usersonchannel")+": " + names.size());
		else {
			String temp, str = "";
			Enumeration e = names.elements();

			while(e.hasMoreElements()) {
				char mode;

				temp = ((String) e.nextElement());
				if (temp.charAt(0) == MODE_OP) mode = '@';
				else if (temp.charAt(0) == MODE_HALFOP) mode = '%';
				else if (temp.charAt(0) == MODE_VOICE) mode = '+';
				else mode = ' ';
				str += mode + temp.substring(1);
				if (e.hasMoreElements())
					str +=", ";
			}
			writeInfo(Irc.language.get("users")+": " + str);
		}
	}

	private int getNickIndex(String nick) {
		int nsize = names.size();

		for (int i=0; i<nsize; i++) {
			String n = (String) names.elementAt(i);
			if (n.substring(1).equals(nick)) {
				return i;
			}
		}
		return -1;
	}

	private void listnames(Command c, Displayable s) {
		nameslist = new List(Irc.language.get("users"), List.IMPLICIT);
		if (this.name.equals(Irc.language.get("channelslist"))) nameslist.setTitle(Irc.language.get("channelslist"));
		int mp = (person_position+1)*MAX_LIST_PERSONS;
		if (person_position>0) {
			nameslist.append("["+Irc.language.get("previous")+"]", Images.icons.getImage(0));
		}
		
		if (names.size()>mp) {
			nameslist.append("["+Irc.language.get("next")+"]", Images.icons.getImage(0));					
		}
	
		for(int i=(person_position*MAX_LIST_PERSONS); i<mp && i <names.size(); i++) {
			String n = (String) names.elementAt(i);
			if 		(n.charAt(0) == MODE_OP) 		nameslist.append(n.substring(1), Images.icons.getImage(1));
			else if (n.charAt(0) == MODE_HALFOP) 	nameslist.append(n.substring(1), Images.icons.getImage(2));
			else if (n.charAt(0) == MODE_VOICE) 	nameslist.append(n.substring(1), Images.icons.getImage(3));
			else 									nameslist.append(n.substring(1), Images.icons.getImage(4));
		}
		nameslist.addCommand(cmd_closenamfav);
		nameslist.setCommandListener(this);
		uihandler.setDisplay(nameslist);
	}

	private void paintAllOnGraphics(Graphics g){
		Font headerfont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_SMALL);
		g.setClip(0, 0, uihandler.ti.getWidth(), uihandler.ti.getHeight());
		g.setColor(100, 140, 100);
		g.fillRect(0, 0, width, height);

		int i;
		g.setColor(10, 10, 10);
		g.drawLine(width - 10,height - 5, width - 4, height - 5);
		g.drawLine(width - 9, height - 4, width - 5, height - 4);
		g.drawLine(width - 8, height - 3, width - 6, height - 3);
		g.drawLine(width - 7, height - 2, width - 7, height - 2);

		g.drawLine(3,height - 6, 10, height - 6);
		g.drawLine(3,height - 2, 10, height - 2);
		g.drawLine(3,height - 6, 3, height - 2);
		g.drawLine(10,height - 6, 10, height - 2);
		g.drawLine(3,height - 6, 6, height - 3);
		g.drawLine(7,height - 3, 10, height - 6);

		// indicators drawn here
		int[] wins = uihandler.getIndicators();
		for (i=0; i<wins.length; i++) {
			switch (wins[i]) {
				case STATE_NONE:
					g.setColor(255, 255, 255);
					break;
				case STATE_INFO:
					g.setColor(170, 170, 170);
					break;
				case STATE_MSG:
					g.setColor(170, 0, 170);
					break;
				case STATE_HILIGHT:
					g.setColor(170, 0, 0);
					break;
				case STATE_SELECTED:
					g.setColor(0, 0, 0);
					break;
			}
			g.fillRect(15+(i*6), height-6, 5, 5);
		}

		// draw header text
		int temp=0;
		if(showtime){
			Utils.drawFramedText(g, headerfont, Utils.getTime(), 2, 0, 0xffffff, 0x000000);
			temp = headerfont.stringWidth(Utils.getTime())+4;
		}
		g.setFont(headerfont);
		g.setColor(0x000000);
		if (headerfont.stringWidth(header + chansize + temp) < width-5)
			g.drawString(header + chansize,  2+ temp, 0, Graphics.LEFT | Graphics.TOP);
		else {
			// not enough space, we need to cut
			int textwidth = width-5-temp-headerfont.stringWidth(chansize);
			textwidth -= headerfont.stringWidth(".." + header.substring(header.length()-2));
			for (i=header.length()-3; i>=0 && headerfont.substringWidth(header, 0, i)>textwidth; i--);
			g.drawString(header.substring(0, i) + ".." + header.substring(header.length()-2) + chansize, 2+temp, 0, Graphics.LEFT | Graphics.TOP);
		}

		textarea.paint(g, 1, headerfont.getHeight());
		if (uihandler.keylock){
			Resources.LCDOff();
			g.setColor(80, 80, 80);
			for(int n=0; n<2*height; n+=2) g.drawLine(n-height, 0, n, height);
			g.drawImage(Images.icons.getImage(5), width - 15, height - 15, Graphics.LEFT | Graphics.TOP);
			
			Font font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_LARGE);
			Utils.drawFramedText(g, font, Utils.getTime(), width/2 - font.stringWidth(Utils.getTime())/2, height-30 -(font.getHeight()-Images.icons.getHeight())/2, 0xffffff, 0x000000);
			
		}
	}
	
	public void paint(Graphics g) {
		paintAllOnGraphics(uihandler.tg);
		g.drawImage(uihandler.ti, 0, 0, Graphics.LEFT | Graphics.TOP);
	}

	/* triggers and callbacks start from here */
	protected void keyReleased(int keyCode) {
		if (keyCode == KEY_POUND) {
			if (System.currentTimeMillis()-keylocktime >= 1000) {
				if (!uihandler.keylock) {
					Alert a = new Alert(Irc.language.get("info"), Irc.language.get("keyboardblocked"), null, AlertType.INFO);
					a.setTimeout(1000);
					uihandler.setDisplay(a);
					uihandler.setWinlock(true);
				}
				else {
					Alert a = new Alert(Irc.language.get("info"), Irc.language.get("keyboardunblocked"), null, AlertType.INFO);
					a.setTimeout(1000);
					uihandler.setDisplay(a);			
					uihandler.setWinlock(false);
				}

				uihandler.keylock = !uihandler.keylock;
				keylocktime = 0;
				repaint();
				return;
			}else this.commandAction(cmd_menu, null);
		}		
	}
	protected void keyPressed(int keyCode) {
		if (keyCode == KEY_POUND) {
			keylocktime = System.currentTimeMillis();

			if (!uihandler.keylock){
  				Irc.forceUpdate();
   			}else Resources.LCDOff();
			return; // no other function for 5
		}else keylocktime = 0;

		if (uihandler.keylock) {
			// show information
	             Resources.LCDOff();
		 }else if ((keyCode >= 97 && keyCode <= 122) || (keyCode >= 65 && keyCode <= 90)) { // BlackBerry
			textbox = new TextBox(Irc.language.get("message"), null, 512, TextField.ANY);
			textbox.insert("" + (char) keyCode, 0);
			textbox.setCommandListener(new TextboxListener());
			textbox.addCommand(cmd_send);
			if(UIHandler.message != null)textbox.addCommand(cmd_paste);
			textbox.addCommand(cmd_smiles);
			textbox.addCommand(cmd_colmsg);
			textbox.addCommand(cmd_styles);
			textbox.addCommand(cmd_cancel);
			uihandler.setWinlock(true);
			uihandler.setDisplay(textbox);
		}else if (keyCode == 137) { // another BlackBerry
			this.commandAction(cmd_msg, null);
		}else if (keyCode == -13 || getGameAction(keyCode) == UP || keyCode == KEY_NUM2) {
			textarea.up();
			repaint();
		}else if (keyCode == -14 || getGameAction(keyCode) == DOWN || keyCode == KEY_NUM8) {
			textarea.down();
			repaint();
		}else if (keyCode == KEY_NUM4 || getGameAction(keyCode) == LEFT) {
			uihandler.displayPreviousWindow();
		}else if (keyCode == KEY_NUM6 || getGameAction(keyCode) == RIGHT) {
			uihandler.displayNextWindow();
		}else if (keyCode == KEY_NUM1) {
			textarea.home();
			repaint();
		}else if (keyCode == KEY_NUM7) {
			textarea.end();
			repaint();
		}else if (keyCode == KEY_NUM3) {
			textarea.pageUp();
			repaint();
		}else if (keyCode == KEY_NUM9) {
			textarea.pageDown();
			repaint();
		}else if (!uihandler.keylock && keyCode == -7 || keyCode == KEY_POUND || keyCode == -4) {
			this.commandAction(cmd_menu, null);
		}else if (!uihandler.keylock && keyCode == -6 || getGameAction(keyCode) == FIRE  || keyCode == KEY_STAR  || keyCode == -1) {
			this.commandAction(cmd_msg, null);
		}
	}
	
	protected void pointerPressed(int x, int y){
		if(		x>=width-17 & x<=width 	&
				y>=height-10 & y<=height		){
			this.commandAction(cmd_menu, null);
		}else if(
				x>=0 		& x<=17 	&
				y>=height-10 & y<=height		){
			this.commandAction(cmd_msg, null);
		}else if(
				x>=18 		& x<=28 	&
				y>=height-10 & y<=height		){
			uihandler.displayPreviousWindow();
		}else if(
				x>=width-27		& x<=width-18 	&
				y>=height-10 & y<=height		){
			uihandler.displayNextWindow();
		}else if(
				x>=width-10 		& x<=width 	&
				y>=5				& y<=20		){
			textarea.up();
			repaint();
		}else if(
				x>=width-10 		& x<=width 	&
				y>=height-25 		& y<=height-11){
			textarea.down();
			repaint();
		}
	}

	public void commandAction(Command c, Displayable s) {
		if (c == cmd_msg) {
			textbox = new TextBox(Irc.language.get("message"), null, 5000, TextField.ANY);
			textbox.addCommand(cmd_send);
			if(UIHandler.message != null)textbox.addCommand(cmd_paste);
			textbox.addCommand(cmd_smiles);
			textbox.addCommand(cmd_colmsg);
			textbox.addCommand(cmd_styles);
			textbox.addCommand(cmd_cancel);
			textbox.setCommandListener(new TextboxListener());
			uihandler.setWinlock(true);
			uihandler.setDisplay(textbox);
		}
		else if (c == cmd_menu) {
		setFullScreenMode(false);

	    menulist = new List(Irc.language.get("menu"), List.IMPLICIT);
		if (type == Window.TYPE_PRIVATE) menulist.append("Whois", Images.icons.getImage(0));
		if (type == Window.TYPE_CHANNEL) 
			if (this.name.indexOf(Irc.language.get("channelslist")) > -1) menulist.append(Irc.language.get("channelslist"), Images.icons.getImage(0));
			else menulist.append(Irc.language.get("userslist"), Images.icons.getImage(0));
		menulist.append(Irc.language.get("textoptions"), Images.icons.getImage(0));
		menulist.append(Irc.language.get("commands"), Images.icons.getImage(0));
		menulist.append(Irc.language.get("favourite"), Images.icons.getImage(0));
		//FIXME
		menulist.append(Irc.language.get("backgroundmode"), Images.icons.getImage(0));
		menulist.append(Irc.language.get("traffic"), Images.icons.getImage(0));
		if (type == Window.TYPE_PRIVATE || type == Window.TYPE_CHANNEL){
			menulist.append(Irc.language.get("wndclear"), Images.icons.getImage(0));
			menulist.append(Irc.language.get("wndclose"), Images.icons.getImage(0));
		}
		menulist.append(Irc.language.get("disconnect"), Images.icons.getImage(0));
		menulist.addCommand(cmd_closenamfav);
		menulist.setCommandListener(this);
		uihandler.setDisplay(menulist);
		}
		else if (menulist != null && c == List.SELECT_COMMAND) {
			String menuitem = menulist.getString(menulist.getSelectedIndex());
			if (menuitem.equals("Whois")) {
				this.commandAction(cmd_whois, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("userslist"))|menuitem.indexOf(Irc.language.get("channelslist")) > -1){
				this.commandAction(cmd_names, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("textoptions"))) {
				this.commandAction(cmd_textoptions, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("backgroundmode"))) {
				Irc.lastDisplay = this;
				Irc.minimized = true;
				uihandler.setDisplay(null);
			}
			else if (menuitem.equals(Irc.language.get("wndoptions"))) {
				this.commandAction(cmd_options, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("favourite"))) {
				this.commandAction(cmd_favourites, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("traffic"))) {
				this.commandAction(cmd_traffic, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("commands"))) {
				this.commandAction(cmd_commands, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("wndclear"))) {
				menulist = null;
				clear();
				show();
			}
			else if (menuitem.equals(Irc.language.get("wndclose"))) {
				this.commandAction(cmd_close, null);
				menulist = null;
			}
			else if (menuitem.equals(Irc.language.get("disconnect"))) {
				this.commandAction(cmd_disconnect, null);
				menulist = null;
			}
		}
		else if (c == cmd_disconnect) {
			Irc.disconnect("QUIT : "+Irc.QUIT_MESSAGE);
			uihandler.clearChanPriv();
			uihandler.cleanup();
		}
		else if (c == cmd_closeconsole) {
			uihandler.cleanup();
		}
		else if (c == cmd_traffic) {
			String str=Irc.language.get("input") + Utils.getKBytes(Irc.getBytesIn()) + " "+Irc.language.get("kb")+"\n";
			str +=Irc.language.get("output") + Utils.getKBytes(Irc.getBytesOut()) +" "+Irc.language.get("kb")+ "\n";
			str +=Irc.language.get("common") + Utils.getKBytes(Irc.getBytesOut() + Irc.getBytesIn())+" "+Irc.language.get("kb") ;
			
			this.commandAction(cmd_closenamfav, null);
			mb = new MessageBox(uihandler.getDisplay(), this, Irc.language.get("traffic"), str, MessageBox.TYPE_INFO, fontsize, height_diff);
			mb.show();
		}
		else if (c == cmd_textoptions) {
			textoptionslist = new List(Irc.language.get("textoptions"), List.IMPLICIT);
			//FIXME
			if(textarea.getItemType(textarea.currentItem) == TextList.TYPE_URL)	textoptionslist.append(Irc.language.get("openURL"), Images.icons.getImage(0));
			textoptionslist.append(Irc.language.get("quote"), Images.icons.getImage(0));
			textoptionslist.append(Irc.language.get("copy"),Images.icons.getImage(0));
			textoptionslist.append(Irc.language.get("addtocopyed"),Images.icons.getImage(0));
			textoptionslist.append(Irc.language.get("savetofavourite"),Images.icons.getImage(0));
			textoptionslist.append(Irc.language.get("clearbuffer"),Images.icons.getImage(0));
			textoptionslist.addCommand(cmd_closenamfav);
			textoptionslist.setCommandListener(this);
			uihandler.setDisplay(textoptionslist);
		}
		else if (textoptionslist != null && c == List.SELECT_COMMAND) {
			String command = textoptionslist.getString(textoptionslist.getSelectedIndex());
			if (command.equals(Irc.language.get("quote"))) {
				textbox = new TextBox(Irc.language.get("message"), "\"\00315,0\002 "+textarea.getSelectedMessage()+"\003\002\"  " ,1000,TextField.ANY);
				textbox.addCommand(cmd_send);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("openURL"))) {
					//FIXME
				wl.onUrlSelect(this, textarea.getSelectedMessage());
				show();
			}
			else if (command.equals(Irc.language.get("copy"))) {
				UIHandler.message = textarea.getSelectedMessage();
				show();
			}
			else if (command.equals(Irc.language.get("addtocopyed"))) {
				UIHandler.message += textarea.getSelectedMessage();
				show();
			}
			else if (command.equals(Irc.language.get("savetofavourite"))) {
				uihandler.addFav(textarea.getSelectedMessage());
				uihandler.saveFavs();
				show();
			}
			else if (command.equals(Irc.language.get("clearbuffer"))) {
				UIHandler.message = "";
				show();
			}
			textoptionslist = null;
		}
		else if (c == cmd_commands) {
		commandslist = new List(Irc.language.get("commands"), List.IMPLICIT);
		commandslist.append(Irc.language.get("action"), Images.icons.getImage(0));
		commandslist.append(Irc.language.get("allaction"), Images.icons.getImage(0));
		commandslist.append(Irc.language.get("joinchannel"),Images.icons.getImage(0));
		commandslist.append(Irc.language.get("query"),Images.icons.getImage(0));
		commandslist.append(Irc.language.get("changenickaction"),Images.icons.getImage(0));
		commandslist.append(Irc.language.get("channelslist"),Images.icons.getImage(0));
		commandslist.append(Irc.language.get("changetopicaction"),Images.icons.getImage(0));
		commandslist.addCommand(cmd_closenamfav);
		commandslist.setCommandListener(this);
		uihandler.setDisplay(commandslist);
		}
		else if (commandslist != null && c == List.SELECT_COMMAND) {
			String command = commandslist.getString(commandslist.getSelectedIndex());
			if (command.equals(Irc.language.get("joinchannel"))) {
				textbox = new TextBox(Irc.language.get("joinchannel"),"",50,TextField.ANY);
				textbox.addCommand(cmd_ok);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("query"))) {
				textbox = new TextBox(Irc.language.get("query"),"",50,TextField.ANY);
				textbox.addCommand(cmd_ok);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("action"))) {
				textbox = new TextBox(Irc.language.get("action"),"",1000,TextField.ANY);
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("allaction"))) {
				textbox = new TextBox(Irc.language.get("allaction"),"",1000,TextField.ANY);
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("channelslist"))) {
				Irc.writeLine("LIST");
				show();
			}
			else if (command.equals(Irc.language.get("changenickaction"))) {
				textbox = new TextBox(Irc.language.get("changenickaction"),"",50,TextField.ANY);
				textbox.addCommand(cmd_ok);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
			else if (command.equals(Irc.language.get("changetopicaction"))) {
				textbox = new TextBox(Irc.language.get("changetopicaction"),topic,1000,TextField.ANY);
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
			}
		commandslist = null;
		}
		else if (c == cmd_options) {
			cg_options = new ChoiceGroup(null, Choice.MULTIPLE);
			cg_options.append(Irc.language.get("vibra"), null);
			cg_options.append(Irc.language.get("sounds"), null);
			cg_options.append(Irc.language.get("timestamp"), null);
			cg_options.append(Irc.language.get("colors")+", "+Irc.language.get("styles"), null);
			cg_options.setSelectedIndex(0, vibra);
			cg_options.setSelectedIndex(1, sound);
			cg_options.setSelectedIndex(2, timestamp);
			cg_options.setSelectedIndex(3, usecol);
			optionsform = new Form(Irc.language.get("wndoptions"));
			optionsform.append(cg_options);
			optionsform.addCommand(cmd_saveoptions);
			optionsform.setCommandListener(this);
			uihandler.setWinlock(false);
			uihandler.setDisplay(optionsform);
		}
		else if (c == cmd_saveoptions) {
			vibra = cg_options.isSelected(0);
			sound = cg_options.isSelected(1);
			timestamp = cg_options.isSelected(2);
			usecol = cg_options.isSelected(3);
			optionsform = null;
 			show();
 		}
		else if (c == cmd_names) {
			listnames(c,s);
		}
		else if (c == cmd_whois) {
			Irc.writeLine("WHOIS " + name);
			namecmdlist = null;
			show();
		}
		else if (c == cmd_close) {
			if (type == Window.TYPE_CHANNEL)
				Irc.writeLine("PART " + name);
			close();
		}
		else if (c == cmd_closenamfav) {
			nameslist = null;
			cg_favourites = null;
			menulist = null;
			textoptionslist = null;
			commandslist = null;
			favform = null;
			uihandler.setWinlock(false);
			show();
		}
		else if (c == cmd_favourites) {
			favform = new Form(Irc.language.get("favourite"));
			Vector list = uihandler.getFavs();

			cg_favourites = new ChoiceGroup(Irc.language.get("favourite"), Choice.MULTIPLE);
			for (int i=0; i<list.size(); i++)
				cg_favourites.append((String) list.elementAt(i), null);
			favform.append(cg_favourites);
			favform.addCommand(cmd_sendfav);
			favform.addCommand(cmd_addnewfav);
			favform.addCommand(cmd_delfav);
			favform.addCommand(cmd_closenamfav);
			favform.setCommandListener(this);
			uihandler.setWinlock(true);
			uihandler.setDisplay(favform);
		}
		else if (c == cmd_sendfav) {
			boolean[] bools = new boolean[cg_favourites.size()];
			cg_favourites.getSelectedFlags(bools);
			for (int i=0; i<bools.length; i++) {
				if (bools[i]) {
					String str = cg_favourites.getString(i);
					handleMsg(str);
				}
			}
			uihandler.setWinlock(false);
			show();
		}else if (c == cmd_addslap) {
			textbox = new TextBox(Irc.language.get("addslap"), "", 1000, TextField.ANY);
			textbox.setCommandListener(new TextboxListener());
			textbox.addCommand(cmd_ok);
			if(UIHandler.message != null)textbox.addCommand(cmd_paste);
			textbox.addCommand(cmd_smiles);
			textbox.addCommand(cmd_colmsg);
			textbox.addCommand(cmd_styles);
			textbox.addCommand(cmd_cancel);
			uihandler.setDisplay(textbox);
		}else if (c == cmd_editslap) {
			if(slapslist.getSelectedIndex()>0){
				textbox = new TextBox(Irc.language.get("editslap"), slapslist.getString(slapslist.getSelectedIndex()), 1000, TextField.ANY);
				textbox.setCommandListener(new TextboxListener());
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
				textbox.addCommand(cmd_smiles);
				textbox.addCommand(cmd_colmsg);
				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				uihandler.setDisplay(textbox);
			}
		}else if (c == cmd_delslap){
			if(slapslist.getSelectedIndex()>0){
				uihandler.removeSlap(slapslist.getString(slapslist.getSelectedIndex()));
				slapslist.delete(slapslist.getSelectedIndex());
				uihandler.saveSlaps();
			}
			uihandler.setDisplay(slapslist);
		}else if (c == cmd_addnewfav) {
			textbox = new TextBox(Irc.language.get("addfavourite"), "", 1000, TextField.ANY);
			textbox.setCommandListener(new TextboxListener());
			textbox.addCommand(cmd_ok);
			if(UIHandler.message != null)textbox.addCommand(cmd_paste);
			textbox.addCommand(cmd_smiles);
			textbox.addCommand(cmd_colmsg);
			textbox.addCommand(cmd_styles);
			textbox.addCommand(cmd_cancel);
			uihandler.setDisplay(textbox);
		}
		else if (c == cmd_delfav) {
			boolean[] bools = new boolean[cg_favourites.size()];
			cg_favourites.getSelectedFlags(bools);
			for (int i=0; i<bools.length; i++)
				if (bools[i]) uihandler.removeFav(cg_favourites.getString(i));

			Vector list = uihandler.getFavs();
			while(cg_favourites.size() > 0) cg_favourites.delete(0);
			for (int i=0; i<list.size(); i++)
				cg_favourites.append((String) list.elementAt(i), null);

			uihandler.saveFavs();
		}			
		else if (slapslist != null && c == List.SELECT_COMMAND) {
			String cmd = slapslist.getString(slapslist.getSelectedIndex());
			String nick = slapslist.getTitle();
			if (cmd.equals("["+Irc.language.get("back")+"]")) {
				namecmdlist = new List(nick, List.IMPLICIT);
				namecmdlist.append("["+Irc.language.get("back")+"]",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("address"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("notice"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("invite"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("query"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("slaps"),Images.icons.getImage(0));
				namecmdlist.append("Whois",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("info")+" CTCP",Images.icons.getImage(0));
				if(UIHandler.nickMode == MODE_OP || UIHandler.nickMode == MODE_HALFOP)
					namecmdlist.append(Irc.language.get("managing"),Images.icons.getImage(0));
				namecmdlist.setCommandListener(this);
				uihandler.setDisplay(namecmdlist);
				slapslist = null;
			}else{
				String slap = Utils.replace(cmd, "%nick%", nick);
				slap = Utils.replace(slap, "%channel%", header);
				handleMsg("/ME " + slap);
				slapslist = null;
				show();
			}
		}else if (nameslist != null && c == List.SELECT_COMMAND) {
			String name = nameslist.getString(nameslist.getSelectedIndex());
			if (name.equals("["+Irc.language.get("next")+"]")) {
				person_position++;
				listnames(c, s);
			}
			else if (name.equals("["+Irc.language.get("previous")+"]")) {
				person_position--;
				listnames(c, s);
			}
			else {
				if (this.name == Irc.language.get("channelslist")){
					Irc.writeLine("JOIN " + name);
					namecmdlist = null;
					show();
				}
				else{
					namecmdlist = new List(name, List.IMPLICIT);
					namecmdlist.append("["+Irc.language.get("back")+"]",Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("address"),Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("notice"),Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("invite"),Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("query"),Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("slaps"),Images.icons.getImage(0));
					namecmdlist.append("Whois",Images.icons.getImage(0));
					namecmdlist.append(Irc.language.get("info")+" CTCP",Images.icons.getImage(0));
					if(UIHandler.nickMode == MODE_OP || UIHandler.nickMode == MODE_HALFOP)
						namecmdlist.append(Irc.language.get("managing"),Images.icons.getImage(0));
					namecmdlist.setCommandListener(this);
					uihandler.setDisplay(namecmdlist);
					nameslist = null;
				}
			}
		}
		else if (namecmdlist != null && c == List.SELECT_COMMAND) {
			String name = namecmdlist.getString(namecmdlist.getSelectedIndex());
			String nick = namecmdlist.getTitle();

			if (name.equals("["+Irc.language.get("back")+"]")) {
				listnames(c, s);
				namecmdlist = null;
			}
			else if (name.equals(Irc.language.get("address"))){
				String temp = uihandler.template_query;
				temp = Utils.replace(temp, "%nick%", nick);
				temp = Utils.replace(temp, "%color%", "\003");
				temp = Utils.replace(temp, "%bold%", "\002");
				temp = Utils.replace(temp, "%italic%", "\037");
				temp = Utils.replace(temp, "%underline%", "\026");
				textbox = new TextBox(Irc.language.get("address"), temp, 10000, TextField.ANY);
				textbox.setCommandListener(new TextboxListener());
				textbox.addCommand(cmd_send);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				uihandler.setDisplay(textbox);
				namecmdlist = null;
			}else if (name.equals(Irc.language.get("notice"))) {
				textbox = new TextBox(Irc.language.get("notice")+" "+nick, "", 10000, TextField.ANY);
				textbox.setCommandListener(new TextboxListener());
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				uihandler.setDisplay(textbox);
				namecmdlist = null;
			}else if (name.equals(Irc.language.get("invite"))) {
				textbox = new TextBox(Irc.language.get("invite")+" "+nick, "", 100, TextField.ANY);
				textbox.setCommandListener(new TextboxListener());
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				uihandler.setDisplay(textbox);
				namecmdlist = null;
			}else if (name.equals(Irc.language.get("query"))) {
				Window p = uihandler.getPrivate(nick);
				state = STATE_NONE;
				namecmdlist = null;
				p.show();
			}else if (name.equals(Irc.language.get("slaps"))) {
				slapslist = new List(nick, List.IMPLICIT);
				Vector slaps = uihandler.getSlaps();
				slapslist.append("["+Irc.language.get("back")+"]", Images.icons.getImage(0));
				for(int i=0; i<slaps.size(); i++) slapslist.append((String) slaps.elementAt(i), Images.icons.getImage(0));
				slapslist.addCommand(cmd_addslap);
				slapslist.addCommand(cmd_editslap);
				slapslist.addCommand(cmd_delslap);
				slapslist.setCommandListener(this);
				uihandler.setDisplay(slapslist);
				namecmdlist = null;
			}else if (name.equals(Irc.language.get("info")+" CTCP")) {
				ctcpmenu = new List(nick, List.IMPLICIT);
				ctcpmenu.append("["+Irc.language.get("back")+"]", Images.icons.getImage(0));
				ctcpmenu.append("VERSION", Images.icons.getImage(0));
				ctcpmenu.append("USERINFO", Images.icons.getImage(0));
				ctcpmenu.append("PING", Images.icons.getImage(0));
				ctcpmenu.append("TIME", Images.icons.getImage(0));
				ctcpmenu.setCommandListener(this);
				uihandler.setDisplay(ctcpmenu);
				namecmdlist = null;
			}
			else if (name.equals(Irc.language.get("managing"))) {
				usermanagmentmenu = new List(nick, List.IMPLICIT);
				usermanagmentmenu.append("["+Irc.language.get("back")+"]",Images.icons.getImage(0));
				usermanagmentmenu.append("Kick("+Irc.language.get("reason")+")",Images.icons.getImage(0));
				usermanagmentmenu.append("Kick",Images.icons.getImage(0));
				usermanagmentmenu.append("Kick+Ban",Images.icons.getImage(0));
				usermanagmentmenu.append("Kick+Ban("+Irc.language.get("reason")+")",Images.icons.getImage(0));
				usermanagmentmenu.append("Ban",Images.icons.getImage(0));
				usermanagmentmenu.append("UnBan",Images.icons.getImage(0));
				usermanagmentmenu.append("Hop",Images.icons.getImage(0));
				usermanagmentmenu.append("DeHop",Images.icons.getImage(0));
				usermanagmentmenu.append("Op",Images.icons.getImage(0));
				usermanagmentmenu.append("Deop",Images.icons.getImage(0));
				usermanagmentmenu.append("Voice",Images.icons.getImage(0));
				usermanagmentmenu.append("Devoice",Images.icons.getImage(0));
				usermanagmentmenu.setCommandListener(this);
				uihandler.setDisplay(usermanagmentmenu);
				namecmdlist = null;
			}
			else if (name.equals("Whois")) {
				Irc.writeLine("WHOIS " + nick);
				namecmdlist = null;
				show();
			}
		}
		else if (ctcpmenu != null && c == List.SELECT_COMMAND) {
			String cmd = ctcpmenu.getString(ctcpmenu.getSelectedIndex());
			String nick = ctcpmenu.getTitle();

			if (cmd.equals("["+Irc.language.get("back")+"]")) {
				namecmdlist = new List(nick, List.IMPLICIT);
				namecmdlist.append("["+Irc.language.get("back")+"]",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("address"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("notice"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("invite"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("query"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("slaps"),Images.icons.getImage(0));
				namecmdlist.append("Whois",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("info")+" CTCP",Images.icons.getImage(0));
				if(UIHandler.nickMode == MODE_OP || UIHandler.nickMode == MODE_HALFOP)
					namecmdlist.append(Irc.language.get("managing"),Images.icons.getImage(0));
				namecmdlist.setCommandListener(this);
				uihandler.setDisplay(namecmdlist);
				ctcpmenu = null;
			}
			else if (cmd.equals("USERINFO")) {
				Irc.writeLine("PRIVMSG " + nick + " :" + "\001USERINFO\001");
				ctcpmenu = null;
				show();
			}
			else if (cmd.equals("VERSION")) {
				Irc.writeLine("PRIVMSG " + nick + " :\001VERSION\001");
				ctcpmenu = null;
				show();
			}
			else if (cmd.equals("TIME")) {
				Irc.writeLine("PRIVMSG " + nick + " :\001TIME\001");
				ctcpmenu = null;
				show();
			}
			else if (cmd.equals("PING")) {
				Irc.writeLine("PRIVMSG " + nick + " :\001PING "+System.currentTimeMillis()+"\001");
				ctcpmenu = null;
				show();
			}
		}
		else if (usermanagmentmenu != null && c == List.SELECT_COMMAND) {
			String cmd = usermanagmentmenu.getString(usermanagmentmenu.getSelectedIndex());
			String nick = usermanagmentmenu.getTitle();


			if (cmd.equals("["+Irc.language.get("back")+"]")) {
				uihandler.setDisplay(namecmdlist);
				namecmdlist = new List(nick, List.IMPLICIT);
				namecmdlist.append("["+Irc.language.get("back")+"]",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("address"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("notice"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("invite"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("query"),Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("slaps"),Images.icons.getImage(0));
				namecmdlist.append("Whois",Images.icons.getImage(0));
				namecmdlist.append(Irc.language.get("info")+" CTCP",Images.icons.getImage(0));
				if(UIHandler.nickMode == MODE_OP || UIHandler.nickMode == MODE_HALFOP)
					namecmdlist.append(Irc.language.get("managing"),Images.icons.getImage(0));
				namecmdlist.setCommandListener(this);
				uihandler.setDisplay(namecmdlist);
				usermanagmentmenu = null;
			}else if (cmd.equals("Kick")) {
				Irc.writeLine("KICK " + this.name + " " + nick + " :" + UIHandler.nick);
				usermanagmentmenu = null;
				show();
			}else if (cmd.equals("Kick+Ban")) {
				Irc.writeLine("MODE " + this.name + " +b " + nick);
				Irc.writeLine("KICK " + this.name + " " + nick + " :" + UIHandler.nick);
				usermanagmentmenu = null;
				show();
			}else if (cmd.equals("Kick("+Irc.language.get("reason")+")")) {
				textbox = new TextBox("Kick("+Irc.language.get("reason")+") "+nick,"",1000,TextField.ANY);
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
				usermanagmentmenu = null;
			}else if (cmd.equals("Kick+Ban("+Irc.language.get("reason")+")")) {
				textbox = new TextBox("Kick+Ban("+Irc.language.get("reason")+") "+nick,"",1000,TextField.ANY);
				textbox.addCommand(cmd_ok);
				if(UIHandler.message != null)textbox.addCommand(cmd_paste);
    			textbox.addCommand(cmd_smiles);
   				textbox.addCommand(cmd_colmsg);
   				textbox.addCommand(cmd_styles);
				textbox.addCommand(cmd_cancel);
				textbox.setCommandListener(new TextboxListener());
				uihandler.setWinlock(true);
				uihandler.setDisplay(textbox);
				usermanagmentmenu = null;
			}else {
				String mode = "";
				if (cmd.equals("Op"))
					mode = "+o";
				else if (cmd.equals("Deop"))
					mode = "-o";
				else if (cmd.equals("Hop"))
					mode = "+h";
				else if (cmd.equals("DeHop"))
					mode = "-h";
				else if (cmd.equals("Voice"))
					mode = "+v";
				else if (cmd.equals("Devoice"))
					mode = "-v";
				else if (cmd.equals("Ban"))
					mode = "+b";
				else if (cmd.equals("UnBan"))
					mode = "-b";

				Irc.writeLine("MODE " + this.name + " " + mode + " " + nick);
				usermanagmentmenu = null;
				show();
			}
		}

	}	

	private class Smiles extends Canvas{
	
		private int width;
		private int height;

		private int smiles_on_horizontal;
		private int smiles_on_vertical;
		private int width_of_smile;
	
		private Image ti;
		private Graphics tg;

		private int cursor_x = 0;
		private int cursor_y = 0;
	
		public Smiles(int width, int height) {
	
			this.width = width;
			this.height = height;
			this.smiles_on_horizontal = width/uihandler.emotions.smilesList.getHeight();
			this.smiles_on_vertical = UIHandler.SMILES.length/smiles_on_horizontal;
			this.width_of_smile = width/smiles_on_horizontal;

			ti = Image.createImage(width, height);
			tg = ti.getGraphics();
			draw_smiles(tg);
		}
	
		public void draw_smiles(Graphics g){
			g.setColor(255, 255, 255);
			g.fillRect(0, 0, width, height);
			int smile_index = 0;
			int total_smiles = UIHandler.SMILES.length; 
			for (int y=0; y <= (smiles_on_vertical); y++){
				for (int x=0; x < total_smiles & x < smiles_on_horizontal; x++){
					g.drawImage(uihandler.emotions.smilesList.getImage(smile_index), x*width_of_smile, y*width_of_smile,0);
				    smile_index ++;
				} 
				total_smiles -= smiles_on_horizontal;
			}
		}
	
		public void draw_cursor(Graphics g){
			g.setColor(0,0,0);
			g.drawRect(cursor_x*width_of_smile, cursor_y*width_of_smile,uihandler.emotions.smilesList.getHeight(),uihandler.emotions.smilesList.getHeight());
		}
	
		public void paint(Graphics g) {
			g.drawImage(ti, 0, 0, 0);
			draw_cursor(g);
	}


	    public void keyPressed(int keyCode)
	    {
	        switch(getGameAction(keyCode))
	        {
	        case 1: // '\001'
		if (cursor_y == 0)
			cursor_y = smiles_on_vertical;
		else cursor_y --;
		if (cursor_y*smiles_on_horizontal+cursor_x > UIHandler.SMILES.length-1)  
			cursor_x =UIHandler.SMILES.length - 1 - cursor_y*smiles_on_horizontal;
		repaint();
	            break;
	
	        case 6: // '\006'
		if (cursor_y == smiles_on_vertical)
			cursor_y = 0;
		else cursor_y ++;
		if (cursor_y*smiles_on_horizontal+cursor_x > UIHandler.SMILES.length-1)  
		cursor_x =UIHandler.SMILES.length - 1 - cursor_y*smiles_on_horizontal;
		repaint();
	            break;
	
	        case 2: // '\005'
		if (cursor_x == 0)
			cursor_x = smiles_on_horizontal-1;
		else cursor_x --;
		if (cursor_y*smiles_on_horizontal+cursor_x > UIHandler.SMILES.length-1)  
			cursor_x =UIHandler.SMILES.length - 1 - cursor_y*smiles_on_horizontal;
		repaint();
	            break;
		
	        case 5: // '\002'
		if (cursor_x == smiles_on_horizontal-1)
			cursor_x = 0;
		else cursor_x ++;
		if (cursor_y*smiles_on_horizontal+cursor_x > UIHandler.SMILES.length-1)  
			cursor_x =UIHandler.SMILES.length - 1 - cursor_y*smiles_on_horizontal;
		repaint();
	            break;
	
	        case 8: // '\b'
		textbox.insert(UIHandler.SMILES[cursor_y*smiles_on_horizontal+cursor_x][0], textbox.getCaretPosition());
		uihandler.setDisplay(textbox);
		cursor_y=0;
		cursor_x=0;
	            break;
	        }
	    }
	}

	private class TextboxListener implements CommandListener {
		public void commandAction(Command c, Displayable s) {
			uihandler.setWinlock(false);
			if (c == cmd_send){
				if(!textbox.getString().equals("")){
					handleMsg(textbox.getString());
					show();
					textbox = null;
				}
				else{
					show();
					textbox = null;
				}
			}	
			else if (c == cmd_cancel) {
				if (textbox.getTitle().equals(Irc.language.get("addfavourite"))){
					textbox = null;
					uihandler.setDisplay(favform);
				}else if(textbox.getTitle().equals(Irc.language.get("addslap")) || textbox.getTitle().equals(Irc.language.get("editslap"))){
					textbox = null;
					uihandler.setDisplay(slapslist);
				}else {
					textbox = null;
					show();
				}
			}
			else if (c == cmd_textboxmenu) {
				textboxmenu = new List(Irc.language.get("menu"), List.IMPLICIT);
				textboxmenu.append(Irc.language.get("paste"), Images.icons.getImage(0));
				textboxmenu.append(Irc.language.get("smiles"), Images.icons.getImage(0));
				textboxmenu.append(Irc.language.get("colors"), Images.icons.getImage(0));
				textboxmenu.append(Irc.language.get("styles"), Images.icons.getImage(0));
				textboxmenu.append(Irc.language.get("cancel"), Images.icons.getImage(0));
				textboxmenu.setCommandListener(this);
				uihandler.setDisplay(textboxmenu);
			}
			else if (textboxmenu != null && c == List.SELECT_COMMAND) {
				String item = textboxmenu.getString(textboxmenu.getSelectedIndex());
				if (item.equals(Irc.language.get("smiles"))) {
					this.commandAction(cmd_smiles, null);
				}
				else if (item.equals(Irc.language.get("paste"))) {
					this.commandAction(cmd_paste, null);
				}
				else if (item.equals(Irc.language.get("colors"))) {
					this.commandAction(cmd_colmsg, null);
				}
				else if (item.equals(Irc.language.get("styles"))) {
					this.commandAction(cmd_styles, null);
				}
				else if (item.equals(Irc.language.get("cancel"))) {
					this.commandAction(cmd_cancel, null);
				textboxmenu = null;
				}
			}
			else if (c == cmd_colmsg) {
				cg_colmsg = new ChoiceGroup(Irc.language.get("fontcolor"), Choice.EXCLUSIVE);
				cg_colmsg.append(Irc.language.get("white"), null);
				cg_colmsg.append(Irc.language.get("black"), null);
				cg_colmsg.append(Irc.language.get("blue"), null);
				cg_colmsg.append(Irc.language.get("green"), null);
				cg_colmsg.append(Irc.language.get("darkred"), null);
				cg_colmsg.append(Irc.language.get("brown"), null);
				cg_colmsg.append(Irc.language.get("purple"), null);
				cg_colmsg.append(Irc.language.get("orange"), null);
				cg_colmsg.append(Irc.language.get("yellow"), null);
				cg_colmsg.append(Irc.language.get("lightgreen"), null);
				cg_colmsg.append(Irc.language.get("darkgreen"), null);
				cg_colmsg.append(Irc.language.get("lightblue"), null);
				cg_colmsg.append(Irc.language.get("darkblue"), null);
				cg_colmsg.append(Irc.language.get("pink"), null);
				cg_colmsg.append(Irc.language.get("darkgray"), null);
				cg_colmsg.append(Irc.language.get("gray"), null);
				cg_colmsg.setSelectedIndex(1, true);
				cg_colmsgfone = new ChoiceGroup(Irc.language.get("bgcolor"), Choice.EXCLUSIVE);
				cg_colmsgfone.append(Irc.language.get("white"), null);
				cg_colmsgfone.append(Irc.language.get("black"), null);
				cg_colmsgfone.append(Irc.language.get("blue"), null);
				cg_colmsgfone.append(Irc.language.get("green"), null);
				cg_colmsgfone.append(Irc.language.get("darkred"), null);
				cg_colmsgfone.append(Irc.language.get("brown"), null);
				cg_colmsgfone.append(Irc.language.get("purple"), null);
				cg_colmsgfone.append(Irc.language.get("orange"), null);
				cg_colmsgfone.append(Irc.language.get("yellow"), null);
				cg_colmsgfone.append(Irc.language.get("lightgreen"), null);
				cg_colmsgfone.append(Irc.language.get("darkgreen"), null);
				cg_colmsgfone.append(Irc.language.get("lightblue"), null);
				cg_colmsgfone.append(Irc.language.get("darkblue"), null);
				cg_colmsgfone.append(Irc.language.get("pink"), null);
				cg_colmsgfone.append(Irc.language.get("darkgray"), null);
				cg_colmsgfone.append(Irc.language.get("gray"), null);
				cg_colmsgfone.setSelectedIndex(0, true);
				colmsgform = new Form(Irc.language.get("colors"));
				colmsgform.append(cg_colmsg);
				colmsgform.append(cg_colmsgfone);
				colmsgform.addCommand(cmd_addcol);
				colmsgform.setCommandListener(this);
				uihandler.setWinlock(true);
				uihandler.setDisplay(colmsgform);
			}
			else if (c == cmd_addcol) {
				textbox.insert("\003"+cg_colmsg.getSelectedIndex()+","+cg_colmsgfone.getSelectedIndex(), textbox.getCaretPosition());
				uihandler.setDisplay(textbox);
				colmsgform = null;
			}
			else if (c == cmd_smiles) {
				uihandler.setDisplay(sml);
			}
			else if (c == cmd_paste) {
				if(UIHandler.message != null){
					textbox.insert(UIHandler.message, textbox.getCaretPosition());
				}
				uihandler.setDisplay(textbox);
			}
			else if (c == cmd_styles) {
				cg_styles = new ChoiceGroup(Irc.language.get("styles"), Choice.MULTIPLE);
				cg_styles.append(Irc.language.get("bold"), null); 
				cg_styles.append(Irc.language.get("underlined"), null);
				cg_styles.append(Irc.language.get("italic"), null); 
				cg_styles.setSelectedIndex(0, false);
				cg_styles.setSelectedIndex(1, false);
				cg_styles.setSelectedIndex(2, false);
				stylesform = new Form(Irc.language.get("styles"));
				stylesform.append(cg_styles);
				stylesform.addCommand(cmd_applystyle);
				stylesform.setCommandListener(this);
				uihandler.setWinlock(true);
				uihandler.setDisplay(stylesform);
			}
			else if (c == cmd_applystyle){
				if(cg_styles.isSelected(0))	textstyle += '\002';
				if(cg_styles.isSelected(1))	textstyle += '\037';
				if(cg_styles.isSelected(2))	textstyle += '\026';
				textbox.insert(textstyle, textbox.getCaretPosition());		
				uihandler.setDisplay(textbox);
				textstyle = "";
				stylesform = null;
			}
			else if (c == cmd_ok) {
				if (textbox.getString().trim().equals("")) return;
				String tbtitle = textbox.getTitle();

				if (tbtitle.equals(Irc.language.get("joinchannel"))) {
					String str = textbox.getString();
					if (!Utils.isChannel(str)) str = "#" + str;
					show();
					Irc.writeLine("JOIN " + str);
					textbox = null;
				}else if (tbtitle.equals(Irc.language.get("editslap"))) {
					String str = textbox.getString();
					if(!slapslist.getString(slapslist.getSelectedIndex()).equals(str)){
						uihandler.removeSlap(slapslist.getString(slapslist.getSelectedIndex()));
						slapslist.set(slapslist.getSelectedIndex(), str, Images.icons.getImage(0));
						uihandler.addSlap(str);
						uihandler.saveSlaps();
					}
					uihandler.setDisplay(slapslist);
					textbox = null;
				}else if (tbtitle.equals(Irc.language.get("addslap"))) {
					String str = textbox.getString();
					uihandler.addSlap(str);
					slapslist.append(str, Images.icons.getImage(0));
					uihandler.setDisplay(slapslist);
					uihandler.saveSlaps();
					textbox = null;
				}else if (tbtitle.equals(Irc.language.get("changenickaction"))) {
					String str = textbox.getString();
					Irc.writeLine("NICK " + str);
					UIHandler.nick = str;
					textbox = null;
					show();
				}else if (tbtitle.indexOf("Kick("+Irc.language.get("reason")+")")>-1) {
					String str = textbox.getString();
					String nick = textbox.getTitle().substring(textbox.getTitle().indexOf(' ')+1);
					Irc.writeLine("KICK " + name + " " + nick + " :" + str);
					textbox = null;
					show();
				}else if (tbtitle.indexOf("Kick+Ban("+Irc.language.get("reason")+")")>-1) {
					String str = textbox.getString();
					String nick = textbox.getTitle().substring(textbox.getTitle().indexOf(' ')+1);
					Irc.writeLine("MODE " + name + " +b " + nick);
					Irc.writeLine("KICK " + name + " " + nick + " :" + str);
					textbox = null;
					show();
				}
				else if (tbtitle.equals(Irc.language.get("action"))) {
					String str = textbox.getString();
					handleMsg("/ME " + str);
					textbox = null;
					show();
				}
				else if (tbtitle.equals(Irc.language.get("allaction"))) {
					String str = textbox.getString();
					uihandler.globalHandleMsg("/ME " + str);
					textbox = null;
					show();
				}
				else if (tbtitle.equals(Irc.language.get("address"))) {
					handleMsg(textbox.getString());
					textbox = null;
					show();
				}
				else if (tbtitle.indexOf(Irc.language.get("notice"))>-1) {
					String str = textbox.getString();
					String nick = textbox.getTitle().substring(textbox.getTitle().indexOf(" ")+1);
					handleMsg("/NOTICE "+nick+" "+ str);
					textbox = null;
					show();
				}
				else if (tbtitle.indexOf(Irc.language.get("invite"))>-1) {
					String str = textbox.getString();
					String nick = textbox.getTitle().substring(textbox.getTitle().indexOf(" ")+1);
					handleMsg("/invite "+nick+" "+ str);
					textbox = null;
					show();
				}
				else if (tbtitle.equals(Irc.language.get("changetopicaction"))) {
					String str = textbox.getString();
					handleMsg("/TOPIC " + str);
					textbox = null;
					show();
				}
				else if (tbtitle.equals(Irc.language.get("query"))) {
					String str = textbox.getString();
					uihandler.setDisplay(uihandler.getPrivate(str));
					textbox = null;
				}
				else if (tbtitle.equals(Irc.language.get("addfavourite"))) {
					String str = textbox.getString();
					uihandler.addFav(str);
					uihandler.saveFavs();

					Vector list = uihandler.getFavs();
					while(cg_favourites.size() > 0) cg_favourites.delete(0);
					for (int i=0; i<list.size(); i++)
						cg_favourites.append((String) list.elementAt(i), null);
					uihandler.setDisplay(favform);
				}
			}
		}	
	}
}
