package lib.GraphicControls;

import java.util.Vector;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.List;

import lib.Font.SampleFont;
import lib.Resources.ImageList;
import lib.Utils.Utils;

public class PageControl extends Canvas{
	private List menuList;
	private Display display;
	private int fontHeight,
				fontSize,
				width,
				height,
				startPage = 0,
				corHeight = 0;
	public int activePage = 0;
	private Vector pages;
	private Font font = null;
	private SampleFont sampleFont = null;;
	private Edit edit;
	private Image ti;
	private Graphics tg;
	private ImageList icons;
	private PageControlCommandListener pcComd;
	private changerThread changer;
	public boolean showMemoryStatus = false;
	
	public PageControl() {
		//FIXME
		//MIDP 2.0
		//setFullScreenMode(true);

		pages = new Vector();
		icons = new ImageList();
		changer = new changerThread();
		changer.setPriority(Thread.MIN_PRIORITY);
		changer.start();
	}
	
	public void setAttributes(Display display, int fontsize, int heightdiff){
		this.display = display;
		this.fontSize = fontsize;
		this.icons = null;
		
		width = getWidth();
		height = getHeight()+heightdiff;
		
		if(fontSize<0){
			sampleFont = new SampleFont("/fonts/font.bin");
			fontHeight = sampleFont.height;
		}else{
			font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, fontSize);
			fontHeight = font.getHeight();
		}
		
		ti = Image.createImage(width, height);
		tg = ti.getGraphics();
		
		if(pages.size()>0){
			updateHeader();
			updateBody();
		}
	}
	public void setAttributes(Display display, int fontsize, int heightdiff, ImageList icons){
		setAttributes(display, fontsize, heightdiff);
		this.icons = icons;
		if(icons != null && icons.getHeight()>fontHeight) corHeight = icons.getHeight()-fontHeight+1;
	}
	public void setPageControlListener(PageControlCommandListener pcComd){
		this.pcComd = pcComd;
	}
//	=============================================	
	public void addPage(String title, List menuList, int imageIndex, ImageList images){
		Page page = new Page(this, title, imageIndex, menuList, width, height-fontHeight-corHeight-2, TextList.CURSOR_RECT, 999, fontSize);
		page.state = Page.STATE_NONE;
		page.textlist.setImageList(images);
		if (pages.size() == 0)page.state = Page.STATE_ACTIVE;
		pages.addElement(page);
		page = null;
		updateBody();
		updateHeader();
	}
	public Page	getPage(int index){
		return (Page) pages.elementAt(index);
	}
	public void setPage(int index, Page page){
		pages.insertElementAt(page, index);
		delPage(index+1);
	}
	public void delPage(int index){
		if(pages.size() > 1){
			pages.removeElementAt(index);
			if(activePage >= index)
				if(activePage == pages.size()){
					if(activePage == startPage) startPage--;
					activePage = pages.size()-1;
				}
			getPage(activePage).state = Page.STATE_ACTIVE;
			updateHeader();
			updateBody();
		}
	}
	public void delAllPages(){
		pages.removeAllElements();
		startPage = activePage = 0;
	}
	public void showNextPage(){
		if(activePage < getSize()-1) showPage(activePage+1);
		else showPage(0);
	}
	public void showPage(int index){
		if(index>-1 && index<getSize()){
			if(index<startPage) startPage=index;
			getPage(activePage).state = Page.STATE_NONE;
			activePage = index;
			getPage(activePage).state = Page.STATE_ACTIVE;
			updateBody();
			updateHeader();
		}
	}
	public void showPrevPage(){
		if(activePage > 0) showPage(activePage-1);
		else showPage(getSize()-1);
	}
	public int getFontHeight(){
		return fontHeight;
	}
	public int getSize(){
		return pages.size();
	}
//	=============================================	
	public void updateHeader(){
		int x = 0,
			i = 0,
			sw = 0,
			sh = 0;
		boolean notDrawedActivePage = false;
		Page page = null;
		String str = "";
		
		tg.setFont(font);
		tg.setColor(223, 223, 223);
		tg.fillRect(x,0, width, fontHeight+3+corHeight);
		tg.setColor(0, 0, 0);
		tg.drawLine(0, fontHeight+3+corHeight, width+3, fontHeight+3+corHeight);
		while ((x < width || !notDrawedActivePage) && (startPage+i)<pages.size() ){
			//    startPage,  startPage+1  ..     
			page = getPage(startPage + i);
			int iconsWidth  = icons!=null && page.imageIndex>-1 && page.imageIndex<icons.getSize() ? icons.getWidth()+1 : 0;
			str = page.title;

			if(fontSize<0){
				sw = sampleFont.stringWidth(str) + iconsWidth+2;
				if(sw>width-10-iconsWidth){
					str = Utils.splitString(str, sampleFont, width-10-iconsWidth-sampleFont.stringWidth("..."))[0];
					str+="...";
				}
				sw = sampleFont.stringWidth(str) + iconsWidth+2;
			}else{
				sw = font.stringWidth(str) + iconsWidth+2;
				if(sw>width-10-iconsWidth){
					str = Utils.splitString(str, font, width-10-iconsWidth-font.stringWidth("..."))[0];
					str+="...";
				}
				sw = font.stringWidth(str) + iconsWidth+2;
			}

			sh = fontHeight + corHeight;
			if(page.state == Page.STATE_ACTIVE){
				notDrawedActivePage = true;
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,0, sw+5, sh+4);
				tg.setColor(150, 150, 0);
				tg.fillRect(x+2,1, sw+3, sh+3);
				tg.setColor(255, 255, 255);
				tg.fillRect(x+3,2, sw+1, sh+2);
				tg.setColor(0, 0, 0);
			}else if(page.state == Page.STATE_NONE){
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,2, sw+5, sh+2);
				tg.setColor(170, 170, 170);
				tg.fillRect(x+2,3, sw+3, sh);
				tg.setColor(225, 225, 225);
				tg.fillRect(x+3,4, sw+1, sh-1);
				tg.setColor(0, 0, 0);
			}else if(page.state == Page.STATE_HLIGHT){
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,2, sw+5, sh+2);
				tg.setColor(170, 0, 0);
				tg.fillRect(x+2,3, sw+3, sh);
				tg.setColor(225, 225, 225);
				tg.fillRect(x+3,4, sw+1, sh-1);
				tg.setColor(250, 80, 80);
			}else if(page.state == Page.STATE_INFO){
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,2, sw+5, sh+2);
				tg.setColor(0, 0, 170);
				tg.fillRect(x+2,3, sw+3, sh);
				tg.setColor(225, 225, 225);
				tg.fillRect(x+3,4, sw+1, sh-1);
				tg.setColor(0, 0, 170);
			}else if(page.state == Page.STATE_MESSAGE){
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,2, sw+5, sh+2);
				tg.setColor(170, 0, 170);
				tg.fillRect(x+2,3, sw+3, sh);
				tg.setColor(225, 225, 225);
				tg.fillRect(x+3,4, sw+1, sh-1);
				tg.setColor(170, 0, 170);
			}else if(page.state == Page.STATE_ACTION){
				tg.setColor(0, 0, 0);
				tg.fillRect(x+1,2, sw+5, sh+2);
				tg.setColor(0, 0, 170);
				tg.fillRect(x+2,3, sw+3, sh);
				tg.setColor(225, 225, 225);
				tg.fillRect(x+3,4, sw+1, sh-1);
				tg.setColor(0, 0, 170);
			}
			if(fontSize<0){
				sampleFont.drawString(tg, str, x+iconsWidth+3, 1+corHeight);
			}else{
				tg.drawString(str, x+iconsWidth+3, 3+corHeight, Graphics.LEFT | Graphics.TOP);
			}
			if(icons!=null && page.imageIndex>-1 && page.imageIndex<icons.getSize() ) icons.drawImage(tg, page.imageIndex, x+4, 4);
			x += sw+6;
			i++;
		}
		if(page.state == Page.STATE_ACTIVE && x>=width){
			startPage++;
			updateHeader();
		}
		repaint(0, 0, width, sh+6);
		page = null;
	}
	public void updateBody(){
		getPage(activePage).textlist.paint(tg, 0, fontHeight+corHeight+3);
		//   
		tg.setColor(235, 100, 0);
		tg.drawLine(width - 14, height - 7, width - 9, height - 7);
		tg.drawLine(width - 13, height - 6, width - 10, height - 6);
		tg.drawLine(width - 12, height - 5, width - 11, height - 5);
		//========================
		repaint(0, fontHeight+corHeight+4, width, height-fontHeight-corHeight-4);
	}
//	=============================================
	public void setDisplay(Displayable d){
		display.setCurrent(d);
	}
//	=============================================
	public void drawMemoryStatus(Graphics g){
		String 	total = Utils.getKBytes(Runtime.getRuntime().totalMemory()) +" ",
		used = Utils.getKBytes(Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory()) +" ";

		g.setColor(0x000000);
		g.fillRect(0, height-2*fontHeight, font.stringWidth(total), 2*fontHeight);
		g.setColor(0xffffff);
		g.setFont(font);
		g.drawString(total, 0, height-2*fontHeight, 0);
		g.drawString(used, 0, height-fontHeight, 0);
	}
	protected void paint(Graphics g) {
		g.drawImage(ti, 0, 0, 0);
		
		if(showMemoryStatus) drawMemoryStatus(g);
		
	}
	protected void keyPressed(int keyCode) {
		if 			(getGameAction(keyCode) == UP 		|| keyCode == KEY_NUM2 || keyCode == -13){
			changer.type = changerThread.UP;
			changer.running = true;
			if(pcComd!=null)pcComd.onUp(this);
		}else if 	(getGameAction(keyCode) == DOWN 	|| keyCode == KEY_NUM8 || keyCode == -14){
			changer.type = changerThread.DOWN;
			changer.running = true;
			if(pcComd!=null)pcComd.onDown(this);
		}else if 	(getGameAction(keyCode) == LEFT 	|| keyCode == KEY_NUM4 ){
			changer.type = changerThread.PREV;
			changer.running = true;
			if(pcComd!=null)pcComd.onLeft(this);
		}else if 	(getGameAction(keyCode) == RIGHT 	|| keyCode == KEY_NUM6 ){
			changer.type = changerThread.NEXT;
			changer.running = true;
			if(pcComd!=null)pcComd.onRight(this);
		}else if 	(keyCode == KEY_NUM1){
			getPage(activePage).textlist.home();
			updateBody();
		}else if 	(keyCode == KEY_NUM7){
			getPage(activePage).textlist.end();
			updateBody();
		}else if 	(keyCode == KEY_NUM3){
			getPage(activePage).textlist.pageUp();
			updateBody();
		}else if 	(keyCode == KEY_NUM9){
			getPage(activePage).textlist.pageDown();
			updateBody();
		}else if 	(keyCode == KEY_POUND || keyCode == -7 || keyCode == -4){
			setDisplay(getPage(activePage).menuList);
		}else if 	(getGameAction(keyCode) == FIRE){
			if(pcComd!=null)pcComd.onEnter(this);
		}else if 	(keyCode == KEY_NUM0){
			showMemoryStatus = !showMemoryStatus;
			updateBody();
		}
		if(pcComd!=null) pcComd.onKeyPress(this, keyCode);
	}
	protected void keyReleased(int keyCode){
		changer.running=false;
	}
//	=============================================
//  ,    ,
//    ,   
	private class changerThread extends Thread{
		public static final int	PREV = 0,
								NEXT = 1,
								UP	 = 2,
								DOWN = 3;
							
		public int type = NEXT;
		public boolean running = false;
		
		public changerThread(){
		}
		
		public void run(){
			while(this != null){
				if(running){
					if(type == NEXT)showNextPage();
					else if(type == PREV)showPrevPage();
					else if(type == UP){
						getPage(activePage).textlist.up();
						updateBody();
					}else if(type == DOWN){
						getPage(activePage).textlist.down();
						updateBody();
					}try{sleep(70);}catch(InterruptedException e){}
				}
			}
		}
	}

}
