package lib.Utils;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.Calendar;
import java.util.Hashtable;
import java.util.TimeZone;
import java.util.Vector;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;

import lib.Font.SampleFont;

public class Utils {
	static char[] koi8rmap = "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\u00A0\u2321\u00B0\u00B2\u00B7\u00F7\u2550\u2551\u2552\u0451\u2553\u2554\u2555\u2556\u2557\u2558\u2559\u255A\u255B\u255C\u255D\u255E\u255F\u2560\u2561\u0401\u2562\u2563\u2564\u2565\u2566\u2567\u2568\u2569\u256A\u256B\u256C\u00A9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A".toCharArray();
	static char[] cp1251map = "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u040C\u040B\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u045C\u045B\u045F\u00A0\u040E\u045E\u0408\u00A4\u0490\u00A6\u00A7\u0401\u00A9\u0404\u00AB\u00AC\u00AD\u00AE\u0407\u00B0\u00B1\u0406\u0456\u0491\u00B5\u00B6\u00B7\u0451\u2116\u0454\u00BB\u0458\u0405\u0455\u0457\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F".toCharArray();
	protected static Hashtable hashmap = null;

	public static String getTime(){
		Calendar cal = Calendar.getInstance();
		return cal.get(Calendar.HOUR_OF_DAY) + ":" +(cal.get(Calendar.MINUTE)<10?"0":"") + cal.get(Calendar.MINUTE);
	}

	private static String intToStr(int value, int length) {
        String result = Integer.toString(value);
        result = "0000".substring(result.length(), length) + result;
        return result;
    }

    public static String getCanonicalDate(Calendar calendar, TimeZone timezone) {
        String monthNames = "JanFebMarAprMayJunJulAugSepOctNovDec";
        String dayNames = "SunMonTueWedThuFriSatSun";

        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int weekday = calendar.get(Calendar.DAY_OF_WEEK) - 1;
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);

       String result = dayNames.substring(3 * weekday, 3 * weekday + 3) + ", "
        + intToStr(day, 2) + " "
        + monthNames.substring(3 * month, 3 * month + 3) + " "
        + intToStr(year, 4) + " "
        + intToStr(hour, 2) + ":"
        + intToStr(minute, 2) + ":"
        + intToStr(second, 2);

        if (timezone != null) {
            int offset = timezone.getRawOffset() / 1000;
            if (timezone.useDaylightTime()) offset = offset + 3600;

            String name;
            if (offset >= 0) {
                name = " GMT+";
            }
            else {
                name = " GMT-";
                offset = -offset;
            }

            result = result + name + intToStr(offset / 3600, 2) + intToStr(offset % 3600, 2);
        }

        return result;
    }
	public static void drawFramedText(Graphics g, Font font, String text, int left, int top, int textColor, int frameColor){
		g.setFont(font);
		g.setColor(frameColor);
		g.drawString(text, left-1, top, 0);
		g.drawString(text, left+1, top, 0);
		g.drawString(text, left, top-1, 0);
		g.drawString(text, left, top+1, 0);

		g.setColor(textColor);
		g.drawString(text, left, top, 0);
	}
	public static void drawFramedText(Graphics g, SampleFont sampleFont, String text, int left, int top, int textColor, int frameColor){
		sampleFont.setFontColor(frameColor);
		sampleFont.drawString(g, text, left-1, top);
		sampleFont.drawString(g, text, left+1, top);
		sampleFont.drawString(g, text, left, top-1);
		sampleFont.drawString(g, text, left, top+1);

		sampleFont.setFontColor(textColor);
		sampleFont.drawString(g, text, left, top);
	}
	public static String getKBytes(long bytes){
		String 	result,
				temp;
		
		result = Long.toString(bytes/1024);
		
		if(bytes>1024){
			temp = Long.toString(bytes*1000/1024);
			result+= ","+temp.substring(result.length());
		}else{
			temp = Long.toString(bytes*1000/1024);
			if(bytes<100) result+= ",0"+temp;
			else result+= ","+temp;
		}
		
		return result;
	}
	public static int parseInt(String input) {
		int ret = 0;

		try {
			ret = Integer.parseInt(input);
		} catch (NumberFormatException nfe) {}

		return ret;
	}
	public static String byteArrayToString(byte[] bytes, String encoding) {
		char[] map = null;
		String ret;

		if (encoding.equals("KOI8-R"))
			map = koi8rmap;
		else if (encoding.equals("Windows-1251"))
			map = cp1251map;

		if (map != null) {
			char[] chars = new char[bytes.length];
			for (int i=0; i<bytes.length; i++) {
				byte b = bytes[i];
				chars[i] = (b >= 0) ? (char) b : map[b+128];
			}
			ret = new String(chars);
		}
		else {
			try {
				ret = new String(bytes, encoding);
			} catch (UnsupportedEncodingException uee) {
				ret = new String(bytes);
			}
		}

		return ret;
	}

	private static Hashtable generateHashmap(char[] encmap) {
		Hashtable ret = new Hashtable();

		for (int i=0; i<encmap.length; i++)
			ret.put(new Character(encmap[i]), new Byte((byte) (0x80+i)));

		return ret;
	}

	public static byte[] stringToByteArray(String string, String encoding) {
		byte[] ret;

		if (encoding.equals("KOI8-R") || encoding.equals("Windows-1251")) {
			if (hashmap == null || !encoding.equals((String) hashmap.get("encoding"))) {
				if (encoding.equals("KOI8-R"))
					hashmap = generateHashmap(koi8rmap);
				else if (encoding.equals("Windows-1251"))
					hashmap = generateHashmap(cp1251map);
				hashmap.put("encoding", encoding);
			}

			char[] chars = string.toCharArray();
			byte[] bytes = new byte[chars.length];

			for (int i=0; i<chars.length; i++) {
				if (chars[i]<0x80)
					bytes[i] = (byte) chars[i];
				else {
					Byte b = (Byte) hashmap.get(new Character(chars[i]));
					bytes[i] = (b == null) ? (byte) 0x3f : b.byteValue(); // 0x3f is '?'
				}
			}

			ret = bytes;
		}
		else {
			try {
				ret = string.getBytes(encoding);
			} catch (UnsupportedEncodingException uee) {
				ret = string.getBytes();
			}
		}

		return ret;
	}
	public static String setEncoding(String str, String encoding){
		char[] map = null;
		String ret;
		byte[] bytes = str.getBytes();

		
		if 		(encoding.toUpperCase().equals("KOI8-R")) map = koi8rmap;
		else if (encoding.toUpperCase().equals("WINDOWS-1251")) map = cp1251map;

		if (map != null) {
			char[] chars = new char[bytes.length];
			for (int i=0; i<bytes.length; i++) {
				byte b = bytes[i];
				chars[i] = (b >= 0) ? (char) b : map[b+128];
			}
			ret = new String(chars);
		}
		else {
			try {
				ret = new String(bytes, encoding);
			} catch (UnsupportedEncodingException uee) {
				ret = new String(bytes);
			}
		}
		return ret;
	}
	public static byte[] readLine(InputStream is) throws IOException {
		byte[] ret, buf;
		int i;

		buf = new byte[512];
		for(i=0; i<512; i++) {
			int readbyte = is.read();
			if (readbyte == -1) throw new EOFException();

			buf[i] = (byte) readbyte;
			if (buf[i] == '\n')
				break;
		}
		if (i==512) return null;
		if (i>0 && buf[i-1] == '\r') i--;
		ret = new byte[i];
		System.arraycopy(buf, 0, ret, 0, i);
		return ret;
	}

	public static String[] splitString(String str, Font font, int width){
		Vector temp = new Vector();
		String[] result;
		int i;
		while(str.length()>0){
			for (i=str.length(); i>=0 & font.substringWidth(str, 0, i)>width; i--);
			temp.addElement(str.substring(0, i));
			str = str.substring(i);
		}
		result = new String[temp.size()];
		for(int j=0; j<result.length; j++) {
			result[j] = (String) temp.elementAt(j);
		}
		return result;
	}
	public static String[] splitString(String str, SampleFont sampleFont, int width){
		Vector temp = new Vector();
		String[] result;
		int i;
		while(str.length()>0){
			for (i=str.length(); i>=0 & sampleFont.substringWidth(str, 0, i)>width; i--);
			temp.addElement(str.substring(0, i));
			str = str.substring(i);
		}
		result = new String[temp.size()];
		for(int j=0; j<result.length; j++) {
			result[j] = (String) temp.elementAt(j);
		}
		return result;
	}
	
	public static String[] splitString(String str, int partLen) {
		if (str == null || str.equals(""))
	         return null;

		String[] s;
		Vector v = new Vector();
		
		while(partLen<str.length()){
			System.out.println(str.substring(0, partLen));
			v.addElement(str.substring(0, partLen));
			str = str.substring(partLen+1);
			System.out.println("="+str);
		}
		if(str.length()>0) v.addElement(str);

		s = new String[v.size()];
		for(int i=0; i<s.length; i++) {
			s[i] = (String) v.elementAt(i);
		}
		return s;
		
	}
	public static String[] splitMessageString(String str) {
		String[] s;
		s = new String[1];
		s[0]=str;
		return s;
		
	}

	public static String[] splitString(String str, String delims) {
		if (str == null || str.equals("") || delims == null || delims.length() == 0)
		         return null;

		String[] s;
	  	Vector v = new Vector();
		int pos, newpos;

		pos = 0;
		newpos = str.indexOf(delims, pos);

		while(newpos !=-1) {
			v.addElement(str.substring(pos, newpos));
			pos = newpos + delims.length();
			newpos = str.indexOf(delims, pos);
		}
		v.addElement(str.substring(pos));
		
		s = new String[v.size()];
		for(int i=0; i<s.length; i++) {
			s[i] = (String) v.elementAt(i);
		}
		return s;
	}
	
	public static boolean hasNoValue(String s) {
		return (s == null || s.equals("") || s.getBytes().length ==0);
	}

	public static byte[] intToByteArray(int input, int length){
		byte[] result = new byte[length];
		
		for(int i=0; i<length; i++){
			result[length-1-i] = (byte) input;
			input >>= 8;
		}

		return result;
	}
	
	public static String replace(String source, String str1, String str2){
		while(source.indexOf(str1) > -1){
			source = source.substring(0, source.indexOf(str1))+str2+source.substring(source.indexOf(str1)+str1.length());
		}
		return source;
	}
	
	public static String URLEncode(byte[] input) {
		StringBuffer ret;
		int i, temp;

		if (input==null) return null;

		ret = new StringBuffer();
		for (i=0; i<input.length; i++) {
			temp = input[i] & 0xff; // [-128,127] to [0,255]
			if ((temp >= 0x30 && temp <= 0x39) || // 0-9
			    (temp >= 0x41 && temp <= 0x5a) || // A-Z
			    (temp >= 0x61 && temp <= 0x7a) || // a-z
			     temp == 0x2e || temp == 0x2d ||  // . and -
			     temp == 0x2a || temp == 0x5f) {  // * and _
				ret.append((char) temp);
			}
			else if (temp == 0x20) {
				ret.append('+');
			}
			else {
				ret.append('%');
				if (temp < 16) ret.append('0');
				ret.append(Integer.toHexString(temp));
			}
		}

		return ret.toString();
	}

	public static boolean isChannel(String chan) {
		char temp = ' ';
		if (chan.length() > 0) temp = chan.charAt(0);
		if (temp == '#' || temp == '&' || temp == '!') return true;
		else return false;
	}

	public static String[] mergeStringArray(String[] inp1, String[] inp2) {
		String[] ret = new String[inp1.length + inp2.length];

		System.arraycopy(inp1, 0, ret, 0, inp1.length);
		System.arraycopy(inp2, 0, ret, inp1.length, inp2.length);
		return inp2;
	}
	
	public static byte[] mergeByteArrays(byte[] inp1, byte[] inp2) {
		byte[] ret = new byte[inp1.length + inp2.length];

		System.arraycopy(inp1, 0, ret, 0, 			inp1.length);
		System.arraycopy(inp2, 0, ret, inp1.length, inp2.length);
		
		return ret;
	}

	
	public static String formatDateMillis(long millis) {
		return "";
	}
}
